--This is for a mod called Bionis Fields which is a map mod that has a bunch of 
--stuff which adds custom elements and such. This skills are for that mod only
--So these will be unused when that mod isn't added

freeslot("sfx_blueas", "sfx_blueab", "sfx_erhlan", "sfx_erhla2", "sfx_stospk", 
"sfx_stosp2", "sfx_stoham", "sfx_stohab", "sfx_tquake", "sfx_clasol", "sfx_latdis", 
"sfx_tf2pan", "sfx_aquble", "sfx_bluimp", "sfx_maelst", "sfx_hydcan", "sfx_bludrp", 
"sfx_junkbl", "sfx_ascion" ,"SPR_ASCI", "SPR_SVTH", "sfx_silthr", "sfx_lumray", "sfx_avagat", 
"sfx_grapre")

attackDefs["stone_spike"] = {
	name = "Stone Spike",
	type = ATK_EARTH,
	power = 60,
	accuracy = 95,
	costtype = CST_SP,
	cost = 4,
	desc = "Orbal Art\nLight Earth Damage to one enemy\nMay cause Dizzy",
	status = COND_DIZZY,
	statuschance = 5,
	target = TGT_ENEMY,		
	anim = function(mo, targets, hittargets, timer)
		if timer == 1
			playSound(mo.battlen, sfx_stospk)
		end		
	
		if timer == 20
			local m = P_SpawnMobj(hittargets[1].x, hittargets[1].y, hittargets[1].z, MT_DUMMY)
			localquake(mo.battlen, FRACUNIT*5, 5)
			m.state = S_STONESPIKE1
			damageObject(hittargets[1])
		end
		
		if timer == 40
			localquake(mo.battlen, FRACUNIT*10, 10)
			playSound(mo.battlen, sfx_stosp2)
			for i = 1,5
				local rock = P_SpawnMobj(hittargets[1].x, hittargets[1].y, hittargets[1].z + FRACUNIT*3, MT_FALLINGROCK)
				rock.momx = P_RandomRange(-6, 6)*FRACUNIT
				rock.momy = P_RandomRange(-6, 6)*FRACUNIT
				rock.momz = 5*FRACUNIT
				rock.fuse = TICRATE/2
				rock.scale = FRACUNIT*2
			end
		end
				
		if timer == 65 then return true end
	end,
}

attackDefs["stone_hammer"] = {
	name = "Stone Hammer",
	type = ATK_EARTH,	    		
	power = 140,
	accuracy = 95,
	costtype = CST_SP,
	cost = 8,
	desc = "Orbal Art\nMedium Earth Damage to one enemy\nMay cause Dizzy",
	status = COND_DIZZY,
	statuschance = 5,
	target = TGT_ENEMY,		
	anim = function(mo, targets, hittargets, timer)
		if timer == 1
			playSound(mo.battlen, sfx_stoham)
			for i = 1,10
				local rock = P_SpawnMobj(hittargets[1].x + FRACUNIT,
				hittargets[1].y + FRACUNIT,
				hittargets[1].z + P_RandomRange(1400, 1600)*FRACUNIT, MT_FALLINGROCK)
				rock.momz = -30*FRACUNIT
				rock.scale = FRACUNIT*4
			end
		end
		
		if timer == 25
			local target = hittargets[1]
			localquake(mo.battlen, FRACUNIT*10, 10)
			playSound(mo.battlen, sfx_stohab)
			damageObject(hittargets[1])
			local boom = P_SpawnMobj(hittargets[1].x, hittargets[1].y, hittargets[1].z+20*FRACUNIT, MT_BOSSEXPLODE)
            boom.scale = 1
            boom.state = S_TNTDUST_1
			boom.destscale = FRACUNIT*5
			boom.colorized = true
			boom.scalespeed = ((207*FRACUNIT)/4)/15
			boom.color = SKINCOLOR_BROWN
		end
				
		if timer == 45 then return true end
	end,
}

attackDefs["earth_lance"] = {
	name = "Earth Lance",
	type = ATK_EARTH,	    		
	power = 350,
	accuracy = 95,
	costtype = CST_SP,
	cost = 12,
	desc = "Orbal Art\nHeavy Earth Damage to one enemy\nMay cause Dizzy",
	status = COND_DIZZY,
	statuschance = 5,
	target = TGT_ENEMY,		
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		if timer == 1
			local m = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)				
			m.sprite = SPR_EALC
			m.frame = D
			m.flags2 = $|MF2_SPLAT
			m.tics = 15
			m.scale = FRACUNIT*4
		end
		
		if timer == 15
			local m = P_SpawnMobj(target.x + FRACUNIT*20, target.y + FRACUNIT*15, target.z, MT_DUMMY)				
			m.sprite = SPR_EALC
			m.frame = D
			m.flags2 = $|MF2_SPLAT
			m.tics = 15
			m.scale = FRACUNIT*4
		end	
		
		if timer == 30
			local m = P_SpawnMobj(target.x - 20*FRACUNIT, target.y - 15*FRACUNIT, target.z, MT_DUMMY)				
			m.sprite = SPR_EALC
			m.frame = D
			m.flags2 = $|MF2_SPLAT
			m.tics = 15
			m.scale = FRACUNIT*4
		end
		
		
		if timer == 1
			local m = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)				
			m.state = S_EARTHLANCE1
			m.scale = FRACUNIT*3
			playSound(mo.battlen, sfx_erhlan)
		end
		
		if timer == 15
			local m = P_SpawnMobj(target.x + FRACUNIT*20, target.y + FRACUNIT*15, target.z, MT_DUMMY)				
			m.state = S_EARTHLANCE1
			m.scale = FRACUNIT*3
			playSound(mo.battlen, sfx_erhlan)
		end	
		
		if timer == 30
			local m = P_SpawnMobj(target.x - 20*FRACUNIT, target.y - 15*FRACUNIT, target.z, MT_DUMMY)				
			m.state = S_EARTHLANCE1
			m.scale = FRACUNIT*3
			playSound(mo.battlen, sfx_erhlan)
		elseif timer == 50
			damageObject(target)
			playSound(mo.battlen, sfx_erhla2)
		elseif timer == 70
			return true
		end
	end,

}

attackDefs["titanic_roar"] = {
	name = "Titanic Roar",
	type = ATK_EARTH,   		
	power = 650,
	accuracy = 95,
	costtype = CST_SP,
	cost = 40,
	desc = "Orbal Art\nSevere Earth Damage to one enemy",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		if timer == 1
		playSound(mo.battlen, sfx_s3kcbl)
		end
	
		if timer < 90
			localquake(mo.battlen, FRACUNIT*10, 10)

			local rock = P_SpawnMobj(P_RandomRange(-500, 500)*FRACUNIT, P_RandomRange(-500, 500)*FRACUNIT, mo.z, MT_FALLINGROCK)
			rock.scale = P_RandomRange(FRACUNIT/8, FRACUNIT)
			rock.momz = P_RandomRange(1, 5)*FRACUNIT
			rock.fuse = 90
		end

		if timer == 10
		or timer == 30
		or timer == 50
		or timer == 75
		or timer == 80
			playSound(mo.battlen, sfx_tquake)
			for i = 1, 5
				local rock = P_SpawnMobj(hittargets[1].x, hittargets[1].y, hittargets[1].z + FRACUNIT*3, MT_GFZDEBRIS)
				rock.momx = P_RandomRange(-6, 6)*FRACUNIT
				rock.momy = P_RandomRange(-6, 6)*FRACUNIT
				rock.momz = 5*FRACUNIT
				rock.fuse = TICRATE/2
				rock.scale = FRACUNIT*2
			end

			localquake(mo.battlen, FRACUNIT*20, 10)
		end
		
		if timer == 95
			localquake(mo.battlen, FRACUNIT*10, 10)
			playSound(mo.battlen, sfx_stosp2)
			damageObject(hittargets[1])
			for i = 1,5
				local rock = P_SpawnMobj(hittargets[1].x, hittargets[1].y, hittargets[1].z + FRACUNIT*3, MT_FALLINGROCK)
				rock.momx = P_RandomRange(-6, 6)*FRACUNIT
				rock.momy = P_RandomRange(-6, 6)*FRACUNIT
				rock.momz = 5*FRACUNIT
				rock.fuse = TICRATE/2
				rock.scale = FRACUNIT*3
			end
		end
		
		if timer == 110 then return true end
	end,
}

attackDefs["quake"] = {
	name = "Quake",
	type = ATK_EARTH,
	power = 60,
	accuracy = 95,
	costtype = CST_SP,
	cost = 8,
	desc = "Orbal Art\nLight Earth Damage to all enemies\nMay cause Dizzy",
	status = COND_DIZZY,
	statuschance = 5,
	target = TGT_ALLENEMIES,		
	anim = function(mo, targets, hittargets, timer)
	
		if timer == 2 
			playSound(mo.battlen, sfx_tquake)
			localquake(mo.battlen, FRACUNIT*5, 10)
		end
		
		if timer == 25 
			playSound(mo.battlen, sfx_tquake)
			localquake(mo.battlen, FRACUNIT*25, 10)
		end
	
		if timer == 50 
			playSound(mo.battlen, sfx_tquake)
			localquake(mo.battlen, FRACUNIT*25, 10)
		end
		
		if timer == 60 
			playSound(mo.battlen, sfx_tquake)
			localquake(mo.battlen, FRACUNIT*25, 10)
		end
		
		if timer == 65
			playSound(mo.battlen, sfx_stosp2)
		end	
	
		for k,v in ipairs(hittargets)
			if timer == 65
				localquake(mo.battlen, FRACUNIT*25, 30)
				damageObject(v)
				for i = 1,5
					local rock = P_SpawnMobj(v.x, v.y, v.z, MT_FALLINGROCK)
					rock.momx = P_RandomRange(-6, 6)*FRACUNIT
					rock.momy = P_RandomRange(-6, 6)*FRACUNIT
					rock.momz = 5*FRACUNIT
					rock.fuse = TICRATE/2
				end
			end
		end
				
		if timer == 80 + #hittargets*3 then return true end
	end,
}

attackDefs["stone_impact"] = {
	name = "Stone Impact",
	type = ATK_EARTH,	    		
	power = 140,
	accuracy = 95,
	costtype = CST_SP,
	cost = 16,
	desc = "Orbal Art\nMedium Earth Damage to all enemies\nMay cause Dizzy",
	status = COND_DIZZY,
	statuschance = 5,
	target = TGT_ALLENEMIES,		
	anim = function(mo, targets, hittargets, timer)	
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
	
	
		if timer == 1
			playSound(mo.battlen, sfx_stoham)
			for i = 1,8
				local rock = P_SpawnMobj(avgx + FRACUNIT,
				avgy + FRACUNIT,
				mo.z + P_RandomRange(1400, 1400)*FRACUNIT, MT_FALLINGROCK)
				rock.momz = -30*FRACUNIT
				rock.scale = FRACUNIT*8
			end
		end
		
		if timer == 25
			localquake(mo.battlen, FRACUNIT*20, 20)
			playSound(mo.battlen, sfx_stohab)
			local boom = P_SpawnMobj(avgx, avgy, mo.z+20*FRACUNIT, MT_BOSSEXPLODE)
            boom.scale = 1
            boom.state = S_TNTDUST_1
			boom.frame = A|FF_FULLBRIGHT
			boom.destscale = FRACUNIT*15
			boom.colorized = true
			boom.color = SKINCOLOR_BROWN
			boom.scalespeed = ((207*FRACUNIT)/4)/15
		end
		
		if timer == 25
			for k,v in ipairs(hittargets)
				damageObject(v)
			end	
		end
				
		if timer == 45 + 10*(#hittargets-1)
			return true
		end	
	end,
}

attackDefs["grand_press"] = {
	name = "Grand Press",
	type = ATK_EARTH,	    		
	power = 350,
	accuracy = 95,
	costtype = CST_SP,
	cost = 24,
	desc = "Orbal Art\nHeavy Earth Damage to all enemies\nMay cause Dizzy",
	status = COND_DIZZY,
	statuschance = 5,
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)	
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		if timer == 1
			playSound(mo.battlen, sfx_grapre)
			S_StartSoundAtVolume(nil,sfx_grapre,70)
		end	

		if timer < 85
			if not (leveltime%10)
				local j = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
				j.sprite = SPR_CRCB
				j.frame = FF_FULLBRIGHT|A
				j.color = SKINCOLOR_BROWN
				j.colorized = true
				j.fuse = TICRATE
				j.scale = 10*FRACUNIT
				j.destscale = 40*FRACUNIT
				j.momz = P_RandomRange(1, 5)*FRACUNIT
				j.renderflags = RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
				j.flags2 = MF2_SPLAT

				P_CreateFloorSpriteSlope(j)
				j.floorspriteslope.o = {
					x = j.x+32*FRACUNIT,
					y = j.y+32*FRACUNIT,
					z = j.z
				}
			end
		end

		if timer == 2 
			localquake(mo.battlen, FRACUNIT*5, 10)
		end
		
		if timer == 25 
			localquake(mo.battlen, FRACUNIT*25, 10)
		end
			
		if timer == 65
			playSound(mo.battlen, sfx_s1b9)
			localquake(mo.battlen, FRACUNIT*69, 75)
		end
		
		if timer == 65
			for k,v in ipairs(hittargets)
				damageObject(v)
			end	
		end
		
		if timer > 65 and timer < 100
			if not (leveltime%5)
				local rx = avgx + P_RandomRange(-128,128)*FRACUNIT
				local ry = avgy + P_RandomRange(-128,128)*FRACUNIT
				local t = P_SpawnMobj(rx, ry, mo.z, MT_THOK)
				t.state = S_ROCKCRUMBLEA //maybe?
				t.scale = 4*FRACUNIT
				t.momz = (P_RandomRange(4,64)/2)*FRACUNIT
				t.fuse = 75
			end
		end	
				
		if timer == 115 + 10*(#hittargets-1)
			return true
		end	
	end,
}

attackDefs["aqua_bleed"] = {
	name = "Aqua Bleed",
	type = ATK_WATER,	    		
	power = 60,
	accuracy = 95,
	costtype = CST_SP,
	cost = 4,
	desc = "Orbal Art\nLight Water Damage to one enemy",
	technical = COND_BURN,
	target = TGT_ENEMY,		
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 15
                local boom = P_SpawnMobj(mo.x,mo.y,mo.z+(FRACUNIT*32), MT_DUMMY)
                boom.scale = FRACUNIT*1
                boom.state = S_THOK
				boom.color = SKINCOLOR_BLUE
				boom.fuse = 15
				boom.momx = (target.x - boom.x)/15
				boom.momy = (target.y - boom.y)/15
				boom.momz = (target.z - boom.z)/15
				target.bruhn = boom 
            elseif timer == 30
                local boom = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
				boom.state = S_SHOT1
				boom.scale = $ + P_RandomRange(0, 65535)*3
				boom.colorized = true
				boom.scale = FRACUNIT*5
				boom.color = SKINCOLOR_SKY
                damageObject(target)

                elseif timer == 70
                    return true
                end
				
            if timer == 10
				playSound(mo.battlen, sfx_splash)
            elseif timer == 30
				playSound(mo.battlen, sfx_eethit)
                playSound(mo.battlen, sfx_aquble)
            end
			
			if target.bruhn and target.bruhn.valid
				local srbtwomoment = P_SpawnGhostMobj(target.bruhn)
				srbtwomoment.colorized = true
				srbtwomoment.color = SKINCOLOR_BLUE
			end
        end,	
}

attackDefs["blue_impact"] = {
	name = "Blue Impact",
	type = ATK_WATER,	    		
	power = 140,
	accuracy = 95,
	costtype = CST_SP,
	cost = 8,
	desc = "Orbal Art\nMedium Water Damage to one enemy",
	technical = COND_BURN,
	target = TGT_ENEMY,		
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer == 1
			S_StartSound(nil, sfx_bluimp)
		end	
		
		if timer >= 1 and timer <= 50
			for i = 1,3
				local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
				thok.flags = MF_NOBLOCKMAP
				thok.color = SKINCOLOR_SAPPHIRE
				if timer%2 then thok.color = SKINCOLOR_ICY end
				thok.frame = A
				thok.tics = 35
				thok.scale = FRACUNIT*2
				thok.scalespeed = FRACUNIT/32
				thok.destscale = 1
				thok.momz = P_RandomRange(5, 10)*FRACUNIT
				thok.momx = P_RandomRange(-6, 6)*FRACUNIT
				thok.momy = P_RandomRange(-6, 6)*FRACUNIT
			end
		end	
		
		if timer >= 10 and timer <= 50
			for i = 1, 2
				local m = P_SpawnMobj(target.x + P_RandomRange(-64, 64)*FRACUNIT, target.y  + P_RandomRange(-64, 64)*FRACUNIT, target.z, MT_DUMMY)
				m.tics = -1
				m.color = SKINCOLOR_SKY
				m.frame = FF_FULLBRIGHT
				m.scale = FRACUNIT*2
				m.momz = FRACUNIT*64
				m.fuse = TICRATE
				m.sprite = SPR_THOK
			end	
		end
		
		if timer == 5
			playSound(mo.battlen, sfx_eethit)
			playSound(mo.battlen, sfx_aquble)
			damageObject(target)
		end
				
		if timer == 65
			return true
		end
	end,
}

attackDefs["blue_ascension"] = {
		name = "Blue Ascension",
		type = ATK_WATER,	    		
		power = 350,
		accuracy = 95,
		costtype = CST_SP,
		cost = 12,
		desc = "Orbal Art\nHeavy Water Damage to one enemy",
		technical = COND_BURN,
		target = TGT_ENEMY,		
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 25
				playSound(mo.battlen, sfx_blueas)
			end

			if timer >= 20 and timer <= 50
				for i = 1,3
					local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_SAPPHIRE
					if timer%2 then thok.color = SKINCOLOR_ICY end
					thok.frame = A
					thok.tics = 35
					thok.scale = FRACUNIT/2
					thok.scalespeed = FRACUNIT/32
					thok.destscale = 1
					thok.momz = P_RandomRange(5, 10)*FRACUNIT
					thok.momx = P_RandomRange(-6, 6)*FRACUNIT
					thok.momy = P_RandomRange(-6, 6)*FRACUNIT
				end
			elseif timer >= 51 and timer <= 60
				if timer == 52
					playSound(mo.battlen, sfx_blueab)
					damageObject(target)
					for i = 1,16
						local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						if i%2 then thok.color = SKINCOLOR_ICY else thok.color = SKINCOLOR_CERULEAN end
						thok.frame = A
						thok.destscale = 1
						thok.tics = 30
						thok.scalespeed = FRACUNIT/6
						thok.angle = ANGLE_22h*(i-1)
						P_InstaThrust(thok, thok.angle, 69*FRACUNIT)
					end
				end
				for i = 1,8
					local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
					thok.color = SKINCOLOR_SKY
					if timer%2 then thok.color = SKINCOLOR_BLUE end
					if i == 1
						thok.color = SKINCOLOR_WHITE
					end
					thok.frame = A
					thok.tics = 35
					thok.scalespeed = FRACUNIT/32
					thok.destscale = 1
					thok.momz = P_RandomRange(15, 30)*FRACUNIT
					thok.momx = P_RandomRange(-6, 6)*FRACUNIT
					thok.momy = P_RandomRange(-6, 6)*FRACUNIT
				end
				if timer == 52
					local m = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					m.state = S_TRAILSSPLASH1
					m.colorized = true
					m.color = SKINCOLOR_SKY
					m.scale = FRACUNIT*15
					m.flags = MF_NOBLOCKMAP
					m.tics = 5 
				end	

			elseif timer == 90
				return true
			end
		end,
}

attackDefs["maelstorm"] = {
	name = "Maelstorm",
	type = ATK_WATER,	    		
	power = 650,
	accuracy = 95,
	costtype = CST_SP,
	cost = 40,
	desc = "Orbal Art\nSevere Water Damage to one enemy",
	target = TGT_ENEMY,		
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer == 1
			S_StartSound(nil,  sfx_maelst)
		end
		
		
		if timer == 10
			local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
			thok.sprite = SPR_THOK
			thok.frame = A|FF_TRANS50
			thok.tics = 150-60
			thok.fuse = 150-60
			thok.scale = $/64
			thok.destscale = FRACUNIT*5
			thok.scalespeed = $*2
			thok.color = SKINCOLOR_CERULEAN
		end
		
		if timer >= 30 and timer <= 90
			for i = 1,3
				local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
				thok.flags = MF_NOBLOCKMAP
				thok.color = SKINCOLOR_SAPPHIRE
				if timer%2 then thok.color = SKINCOLOR_ICY end
				thok.frame = A
				thok.tics = 35
				thok.scale = FRACUNIT/2
				thok.scalespeed = FRACUNIT/32
				thok.destscale = 1
				thok.momz = P_RandomRange(5, 10)*FRACUNIT
				thok.momx = P_RandomRange(-6, 6)*FRACUNIT
				thok.momy = P_RandomRange(-6, 6)*FRACUNIT
			end
		end	
					
		
		if timer == 90
			for k,v in ipairs(mo.allies)
				if v and v.control and v.control.valid
					P_FlashPal(v.control, 5, 10)
				end	
			end				
		end
		
		if timer >= 90 and timer <= 150
			localquake(mo.battlen, FRACUNIT*25, 70)
			for i = 1,3
				local thok = P_SpawnMobj(target.x + P_RandomRange(-20, 20)*FRACUNIT, target.y + P_RandomRange(-20, 20)*FRACUNIT, target.z, MT_DUMMY)
				thok.flags = MF_NOBLOCKMAP
				thok.color = SKINCOLOR_SAPPHIRE
				if timer%2 then thok.color = SKINCOLOR_ICY end
				thok.frame = A
				thok.tics = 35
				thok.scale = FRACUNIT/2
				thok.scalespeed = FRACUNIT/32
				thok.destscale = FRACUNIT*7
				thok.momz = P_RandomRange(5, 20)*FRACUNIT
				thok.momx = P_RandomRange(-20, 20)*FRACUNIT
				thok.momy = P_RandomRange(-20, 20)*FRACUNIT
			end
		end
		
		if timer == 151
			damageObject(target)	
		
		elseif timer == 180
			return true
		end
		
		if target.bruhn and target.bruhn.valid
			local srbtwomoment = P_SpawnGhostMobj(target.bruhn)
			srbtwomoment.colorized = true
			srbtwomoment.color = SKINCOLOR_WAVE
		end		
	end,
}

attackDefs["blue_drop"] = {
	name = "Blue Drop",
	type = ATK_WATER,
	power = 60,
	accuracy = 95,
	costtype = CST_SP,
	cost = 8,
	desc = "Orbal Art\nLight Water Damage to all enemies",
	technical = COND_FREEZE,
	target = TGT_ALLENEMIES,		
	anim = function(mo, targets, hittargets, timer)
		
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		if timer == 1
			playSound(mo.battlen, sfx_bludrp)
		end	
		
		if timer == 10
			local b = P_SpawnMobj(avgx, avgy, mo.z + 300*FRACUNIT, MT_DUMMY)
			b.momz = -15*FRACUNIT
			b.tics = -1
			b.color = SKINCOLOR_CERULEAN
			b.frame = A
			b.state = S_MEGISTAR1
			b.scale = FRACUNIT*1
			b.fuse = TICRATE*8
		end
		
		if timer == 50
			for k,v in ipairs(mo.allies)
				if v and v.control and v.control.valid
					P_FlashPal(v.control, 5, 5)
				end
			end
		end	
		
		if timer >= 50 and timer <= 120
			local b = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
			b.sprite = SPR_ELEM
			b.frame = A|FF_ANIMATE
			b.scale = FRACUNIT*4
			b.fuse = TICRATE*8
		end
		
		if timer >= 50 and timer <= 120
			for i = 1,3
				local thok = P_SpawnMobj(avgx + P_RandomRange(-80, 80)*FRACUNIT, avgy + P_RandomRange(-80, 80)*FRACUNIT, mo.z, MT_DUMMY)
				thok.flags = MF_NOBLOCKMAP
				thok.color = SKINCOLOR_SAPPHIRE
				if timer%2 then thok.color = SKINCOLOR_ICY end
				thok.frame = A
				thok.tics = 35
				thok.scale = FRACUNIT*1
				thok.scalespeed = FRACUNIT/32
				thok.destscale = 1
				thok.momz = P_RandomRange(5, 10)*FRACUNIT
				thok.momx = P_RandomRange(-10, 10)*FRACUNIT
				thok.momy = P_RandomRange(-10, 10)*FRACUNIT
			end
		end	
		
		if timer == 122
			for i = 1, 64
				local t = P_SpawnMobj(avgx, avgy, mo.z, MT_THOK)
				t.tics = TICRATE
				t.fuse = TICRATE
				t.frame = A
				t.momx = P_RandomRange(-32, 32)*FRACUNIT
				t.momy = P_RandomRange(-32, 32)*FRACUNIT
				t.momz = P_RandomRange(-32, 32)*FRACUNIT
				t.color = P_RandomRange(0, 1) and SKINCOLOR_SAPPHIRE or SKINCOLOR_ICY
				t.scale = FRACUNIT*3/2
			end
		end
			
		if timer == 123
			for i = 1,#hittargets -- damageObject must be used on all enemies individually.
				local target = hittargets[i]
				damageObject(target)
			end	
			
		elseif timer == 145
			return true
		end	
	end,
}

attackDefs["hydro_cannon"] = {
	name = "Hydro Cannon",
	type = ATK_WATER,	    		
	power = 140,
	accuracy = 95,
	costtype = CST_SP,
	cost = 16,
	desc = "Orbal Art\nMedium Water Damage to all enemies",
	technical = COND_BURN,
	target = TGT_ALLENEMIES,		
	anim = function(mo, targets, hittargets, timer)	
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		if timer == 10
			playSound(mo.battlen, sfx_hydcan)
		end	
		
		if timer >= 10 and timer <= 80
			for i = 1,3
				local thok = P_SpawnMobj(mo.x + P_RandomRange(-40, 40)*FRACUNIT, mo.y + P_RandomRange(-40, 40)*FRACUNIT, mo.z, MT_DUMMY)
				thok.flags = MF_NOBLOCKMAP
				thok.color = SKINCOLOR_SAPPHIRE
				if timer%2 then thok.color = SKINCOLOR_ICY end
				thok.frame = A
				thok.tics = 35
				thok.scale = FRACUNIT/2
				thok.scalespeed = FRACUNIT/32
				thok.destscale = 1
				thok.momz = P_RandomRange(5, 10)*FRACUNIT
				thok.momx = P_RandomRange(-6, 6)*FRACUNIT
				thok.momy = P_RandomRange(-6, 6)*FRACUNIT
			end
		end	
		
		if timer == 39
			for i = 1,#hittargets -- damageObject must be used on all enemies individually.
				local target = hittargets[i]
				localquake(mo.battlen, FRACUNIT*10, 20)
				local shot = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
				shot.state = S_HYDROCANNON_1
				shot.scale = FRACUNIT*2
				shot.momx = (avgx - shot.x)/5
				shot.momy = (avgy - shot.y)/5
				shot.momz = (mo.z - shot.z)/5
				target.bruhn = shot
			end	
			
		elseif timer == 70
			for i = 1,#hittargets -- damageObject must be used on all enemies individually.
				local target = hittargets[i]
				localquake(mo.battlen, FRACUNIT*15, 20)
				local shot = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
				shot.state = S_HYDROCANNON_1
				shot.scale = FRACUNIT*2
				shot.momx = (avgx - shot.x)/5
				shot.momy = (avgy - shot.y)/5
				shot.momz = (mo.z - shot.z)/5
				target.bruhn = shot
			end	
		end
		
		if timer == 80
			for i = 1,#hittargets -- damageObject must be used on all enemies individually.
				local target = hittargets[i]
				damageObject(target)
			end
		elseif timer == 110
			return true
		end
		
		for i = 1,#hittargets -- damageObject must be used on all enemies individually.
			local target = hittargets[i]
			if target.bruhn and target.bruhn.valid
				local srbtwomoment = P_SpawnGhostMobj(target.bruhn)
				srbtwomoment.colorized = true
				srbtwomoment.color = SKINCOLOR_CERULEAN
			end	
		end
	end,	
}

attackDefs["genesis_flood"] = {
	name = "Genesis Flood",
	type = ATK_WATER,	    		
	power = 350,
	accuracy = 95,
	costtype = CST_SP,
	cost = 24,
	desc = "Orbal Art\nHeavy Water Damage to all enemies",
	technical = COND_BURN,
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)
		
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		if timer == 20
			playSound(mo.battlen, sfx_blueab)
			local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
			m.state = S_GENEFLOOD1
			m.color = SKINCOLOR_WHITE 
			m.scale = FRACUNIT*10
			
		elseif timer == 30
			for i = 1,#hittargets -- damageObject must be used on all enemies individually.
				local target = hittargets[i]
				damageObject(target)
				playSound(mo.battlen, sfx_eethit)
			end
		elseif timer == 50
			return true
		end
	end,
			
}

attackDefs["scrap_bolt"] = {
		name = "Scrap Bolt",
		type = ATK_METAL,
		power = 60,
		accuracy = 95,
		critical = 5,
		costtype = CST_SP,
		cost = 4,
		desc = "Tita's Invention\nLight Metal Damage to a enemy\nCan do crits",
		target = TGT_ENEMY,
		technical = COND_FREEZE,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 20
				damageObject(target)
				playSound(mo.battlen, sfx_tf2pan)

				local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
				d.sprite = SPR_THMP
				d.frame = B|FF_FULLBRIGHT
				d.scale = FRACUNIT/4
				d.destscale = FRACUNIT*3
				d.scalespeed = FRACUNIT/8
				d.fuse = TICRATE-10
				d.tics = d.fuse
				d.momz = FRACUNIT*2
				d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.color = SKINCOLOR_WHITE

				if not target.plyr
					createSplat(mo)
					createSplat(mo)
				end
				localquake(mo.battlen, FRACUNIT*10, 10)
				for i=1,16
					local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
					b.momx = P_RandomRange(-8, 8)*FRACUNIT
					b.momy = P_RandomRange(-8, 8)*FRACUNIT
					b.momz = P_RandomRange(-8, 8)*FRACUNIT
					b.state = S_SSPK1
					b.frame = A|FF_FULLBRIGHT
					b.scale = FRACUNIT*3
					b.destscale = FRACUNIT/12
				end
			elseif timer == 45
				return true
			end
		end,
	}

attackDefs["metal_blast"] = {
		name = "Metal Blast",
		type = ATK_METAL,
		power = 140,
		accuracy = 95,
		critical = 5,
		costtype = CST_SP,
		cost = 8,
		desc = "Tita's Invention\nMedium Metal Damage to a enemy\nCan do crits",
		target = TGT_ENEMY,
		technical = COND_FREEZE,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer >= 20
			and timer <= 30

				local zdiff = ((30-20) - (timer - 20))*mo.scale*16
				local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT + zdiff, MT_DUMMY)
				b.momx = P_RandomRange(-4, 4)*FRACUNIT
				b.momy = P_RandomRange(-4, 4)*FRACUNIT
				b.momz = P_RandomRange(2, 4)*FRACUNIT
				b.state = S_SSPK1
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT/3
				b.destscale = FRACUNIT*12
			end

			if timer == 30
				damageObject(target)
				playSound(mo.battlen, sfx_tf2pan)
				localquake(mo.battlen, FRACUNIT*10, 10)
				for i=1,16
					local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
					b.momx = P_RandomRange(-8, 8)*FRACUNIT
					b.momy = P_RandomRange(-8, 8)*FRACUNIT
					b.momz = P_RandomRange(-8, 8)*FRACUNIT
					b.state = S_SSPK1
					b.frame = A|FF_FULLBRIGHT
					b.scale = FRACUNIT*3
					b.destscale = FRACUNIT/12
				end
			end
			
			if timer == 30
				for i = 1, 32 do
					local p = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*20, MT_DUMMY)
					p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
					p.state = S_SSPK1
					p.scale = mo.scale*2
					p.colorized = true
					p.color = SKINCOLOR_JET
					p.angle = target.angle + P_RandomRange(-30, 30)*ANG1
					p.momz = P_RandomRange(-24, 24)*mo.scale
					P_InstaThrust(p, p.angle, mo.scale*64)
				end

			elseif timer == 75
				return true
			end
		end,
	}

attackDefs["orbal_force"] = {
	name = "Orbal Force",
	type = ATK_METAL,
	power = 350,
	accuracy = 95,
	critical = 5,
	costtype = CST_SP,
	cost = 16,
	desc = "Tita's Invention\nHeavy Metal Damage to a enemy\nCan do crits",
	target = TGT_ENEMY,
	technical = COND_FREEZE,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer == 10
			S_StartSound(nil, sfx_s3kc5l)
		end	
		
		
		if timer >= 10
		and timer <= 40
		and leveltime%5 == 0
			local x = target.x + P_RandomRange(-40, 40)*FRACUNIT
			local y = target.y + P_RandomRange(-40, 40)*FRACUNIT
			local z = target.z + P_RandomRange(0, 30)*FRACUNIT
			for i=1,16
				local b = P_SpawnMobj(x, y, z+2*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-3, 3)*FRACUNIT
				b.momy = P_RandomRange(-3, 3)*FRACUNIT
				b.momz = P_RandomRange(4, 16)*FRACUNIT
				b.state = S_SSPK1
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT*3
				b.destscale = FRACUNIT/12
			end
			for i=1,16
				local b = P_SpawnMobj(x, y, z+20*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-8, 8)*FRACUNIT
				b.momy = P_RandomRange(-8, 8)*FRACUNIT
				b.momz = P_RandomRange(-8, 8)*FRACUNIT
				b.state = S_SSPK1
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT*3
				b.destscale = FRACUNIT/12
			end
		end
		if timer == 20
		or timer == 30
		or timer == 40
			playSound(mo.battlen, sfx_tf2pan)
			for i = 1, 32 do
				local p = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*20, MT_DUMMY)
				p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
				p.state = S_SSPK1
				p.scale = mo.scale*2
				p.colorized = true
				p.color = SKINCOLOR_JET
				p.angle = target.angle + P_RandomRange(-30, 30)*ANG1
				p.momz = P_RandomRange(-24, 24)*mo.scale
				P_InstaThrust(p, p.angle, mo.scale*64)
			end
		end	
		
		if timer == 40
			damageObject(target)
		
		elseif timer == 67
			return true
		end
	end,
}

attackDefs["scrap_wave"] = {
		name = "Scrap Wave",
		type = ATK_METAL,
		power = 60,
		accuracy = 95,
		critical = 5,
		costtype = CST_SP,
		cost = 8,
		desc = "Tita's Invention\nLight Metal Damage to all enemies\nCan do crits",
		target = TGT_ALLENEMIES,
		technical = COND_FREEZE,
		anim = function(mo, targets, hittargets, timer)
			local avgx = 0
			local avgy = 0
			for i = 1, #hittargets do
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = $ / #hittargets *FRACUNIT
			avgy = $ / #hittargets *FRACUNIT

			if timer == TICRATE/2
			or timer == TICRATE/2 + 8

				if timer == TICRATE/2
					playSound(mo.battlen, sfx_buzz2)
					playSound(mo.battlen, sfx_buzz1)
				end
				local ang = 0
				for i = 1, 24 do

					local f = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
					f.state = S_SSPK1
					f.scale = FRACUNIT/2
					f.fuse = TICRATE
					f.destscale = FRACUNIT*4
					f.colorized = true
					f.color = SKINCOLOR_JET
					f.friction = FRACUNIT
					f.angle = ang
					P_InstaThrust(f, f.angle, 50*FRACUNIT)

					f = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
					f.state = S_SSPK1
					f.scale = FRACUNIT
					f.fuse = TICRATE
					f.friction = FRACUNIT
					f.destscale = FRACUNIT*7
					f.angle = ang
					f.colorized = true
					f.color = SKINCOLOR_RED
					P_InstaThrust(f, f.angle, 60*FRACUNIT)

					for i = 1, 8
						f = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
						f.state = S_SSPK1
						f.fuse = TICRATE
						f.friction = FRACUNIT
						f.scale = FRACUNIT/2
						f.colorized = true
						f.color = SKINCOLOR_BLACK
						f.destscale = FRACUNIT*4
						f.angle = ang + P_RandomRange(-15, 15)*ANG1
						P_InstaThrust(f, f.angle, 50*FRACUNIT + P_RandomRange(-16, 16)*FRACUNIT)
					end
					ang = $ + (360/24)*ANG1
				end
			end
			
			if timer >= TICRATE/2
			and timer <= TICRATE/2 + 9
				for i = 1, 16
					local boom = P_SpawnMobj(avgx + P_RandomRange(-48, 48)*FRACUNIT, avgy + P_RandomRange(-48, 48)*FRACUNIT, mo.z, MT_SUPERSPARK)
					boom.momz = P_RandomRange(16, 64)*FRACUNIT
					boom.scale = FRACUNIT*2
				end
			end

			if timer == TICRATE/2 + 10
				for k,v in ipairs(hittargets)
					damageObject(v)
				end
			end

			if timer == TICRATE*5/2
				return true
			end
		end,
}

attackDefs["junk_blast"] = {
	name = "Junk Blast",
	type = ATK_METAL,
	power = 140,
	accuracy = 95,
	critical = 5,
	costtype = CST_SP,
	cost = 16,
	desc = "Tita's Invention\nMedium Metal Damage to all enemies\nCan do crits",
	target = TGT_ALLENEMIES,
	technical = COND_FREEZE,
	anim = function(mo, targets, hittargets, timer)
		for i = 1,#hittargets -- Run this script for as many enemies as there are.
			local target = hittargets[i] -- target is the current enemy in the loop.

			if timer >= 10 and timer <= 40
				if leveltime%2 == 0
					local thok = P_SpawnMobj(target.x, target.y, target.z+5*FRACUNIT, MT_DUMMY)
					thok.state = S_JUNKBLAST1
					thok.tics = 1
					thok.scale = FRACUNIT*2
				end	
			end
			
			if timer == 40 + (i-1)*6 -- Executes the animation on the target 16 tics after the previous.
				for i = 1, 32 do
					local p = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*20, MT_DUMMY)
					p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
					p.state = S_SSPK1
					p.scale = mo.scale*2
					p.colorized = true
					p.color = SKINCOLOR_JET
					p.angle = target.angle + P_RandomRange(-30, 30)*ANG1
					p.momz = P_RandomRange(-24, 24)*mo.scale
					P_InstaThrust(p, p.angle, mo.scale*64)
				end
			
			elseif timer == 41 + (i-1)*6
				damageObject(target) -- Damage the target.
				playSound(mo.battlen, sfx_junkbl)
			end
			
			if timer == 60 + #targets*6
				return true
			end	
		end
	end,	
}

attackDefs["orbal_parts"] = {
	name = "Orbal Waves",
	type = ATK_METAL,
	power = 350,
	accuracy = 95,
	critical = 5,
	costtype = CST_SP,
	cost = 24,
	desc = "Tita's Invention\nHeavy Metal Damage to all enemies\nCan do crits",
	target = TGT_ALLENEMIES,
	technical = COND_FREEZE,
	anim = function(mo, targets, hittargets, timer)
		for i,target in ipairs(hittargets)
			local time = timer-(i*7)
			if time == 10
				playSound(mo.battlen, sfx_cdfm44)
			end
			
			if time > 10 and time < 45
				if leveltime%2 == 0
					local x = target.x + P_RandomRange(-40, 40)*FRACUNIT
					local y = target.y + P_RandomRange(-40, 40)*FRACUNIT
					local z = target.z + P_RandomRange(0, 30)*FRACUNIT
					for i=1,16
						local b = P_SpawnMobj(x, y, z+2*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-3, 3)*FRACUNIT
						b.momy = P_RandomRange(-3, 3)*FRACUNIT
						b.momz = P_RandomRange(4, 16)*FRACUNIT
						b.state = S_SSPK1
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT*1
						b.destscale = FRACUNIT/12
					end
					for i=1,16
						local b = P_SpawnMobj(x, y, z+20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-8, 8)*FRACUNIT
						b.momy = P_RandomRange(-8, 8)*FRACUNIT
						b.momz = P_RandomRange(-8, 8)*FRACUNIT
						b.state = S_SSPK1
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT*1
						b.destscale = FRACUNIT/12
					end
				end	
			end	

			if time == 45
				playSound(mo.battlen, sfx_buzz2)
			end	

			if time == 45 then damageObject(target) end

			if time > 45 and time < 80
				local hit = P_SpawnMobj(target.x + P_RandomRange(-50, 50)*FRACUNIT, target.y + P_RandomRange(-50, 50)*FRACUNIT, target.z, MT_SUPERSPARK)
				hit.momz = 20*FRACUNIT
				hit.color = SKINCOLOR_JET
				hit.colorized = true
				
				local hitagainlol = P_SpawnMobj(target.x + P_RandomRange(-50, 50)*FRACUNIT, target.y + P_RandomRange(-50, 50)*FRACUNIT, target.z, MT_THOK)
				hitagainlol.momz = 36*FRACUNIT
				hitagainlol.color = SKINCOLOR_JET
				
				if not (leveltime%14)
					for k = 1, 36
						local lolusuck = P_SPMAngle(target, MT_SUPERSPARK, k*10*ANG10)
						lolusuck.color = SKINCOLOR_JET
						lolusuck.colorized = true
						P_InstaThrust(lolusuck, k*10*ANG10, P_RandomRange(35, 50)*FRACUNIT)

						local lolusuckstill = P_SPMAngle(target, MT_SPINDUST, k*10*ANG10)
						lolusuckstill.color = SKINCOLOR_JET
						lolusuckstill.colorized = true
						P_InstaThrust(lolusuckstill, k*10*ANG10, P_RandomRange(10, 19)*FRACUNIT)
					end
				end
			end
		end
		
		if timer == 110+(#hittargets*7) then return true end
	end,
}

attackDefs["chaos_brand"] = {
	name = "Chaos Brand",
	type = ATK_GRAVITY,
	power = 60,
	accuracy = 95,
	costtype = CST_SP,
	cost = 4,
	desc = "Orbal Art\nLight Gravity Damage to one enemy",
	target = TGT_ENEMY,	
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		local psiocolors = {SKINCOLOR_MAGENTA, SKINCOLOR_WHITE}

		if timer >= 20 and timer <= 50
			if timer == 20
				playSound(mo.battlen, sfx_karin)
			end
			if not (timer%4)
				local ol = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				ol.sprite = SPR_NTHK
				ol.color = psiocolors[P_RandomRange(1, #psiocolors)]
				ol.scale = 1
				ol.destscale = FRACUNIT*32
				ol.scalespeed = FRACUNIT/5
				ol.frame = B|FF_FULLBRIGHT
				ol.tics = 20

				ol = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				ol.sprite = SPR_NTHK
				ol.color = psiocolors[P_RandomRange(1, #psiocolors)]
				ol.scale = 1
				ol.destscale = FRACUNIT*32
				ol.scalespeed = FRACUNIT
				ol.frame = B|FF_FULLBRIGHT|TR_TRANS50
				ol.tics = 8
			end
		end
		
		if timer == 50
			for i = 1,64
				local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
				thok.color = SKINCOLOR_PURPLE
				if timer%2 then thok.color = SKINCOLOR_MAGENTA end
				if i == 1
					thok.color = SKINCOLOR_WHITE
				end
				thok.frame = A
				thok.tics = 25
				thok.scalespeed = FRACUNIT/25
				thok.destscale = 1
				thok.momz = P_RandomRange(0, 20)*FRACUNIT
				thok.momx = P_RandomRange(-20, 20)*FRACUNIT
				thok.momy = P_RandomRange(-20, 20)*FRACUNIT
			end
			for i = 1,16
				local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				thok.state = S_SSPK1
				thok.angle = ANGLE_22h*(i-1)
				P_InstaThrust(thok, thok.angle, 69*FRACUNIT)
			end
		end	
		
		if timer == 51
			playSound(mo.battlen, sfx_hamas2)
			damageObject(target)
		
		elseif timer == 70
			return true
		end
	end,
}

attackDefs["ascension"] = {
	name = "Ascension",
	type = ATK_GRAVITY,	    		
	power = 140,
	accuracy = 95,
	costtype = CST_SP,
	cost = 8,
	desc = "Orbal Art\nMedium Gravity Damage to one enemy",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]

		if timer == 10
			playSound(mo.battlen, sfx_ascion)
			local m = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)		
			m.sprite = SPR_ASCI
			m.frame = A|FF_TRANS50
			m.scale = FRACUNIT*2
			m.tics = 60
		end	
		
		if timer >= 25
		and timer <= 40
			if not (timer%4)
				for i = 1,16
					local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					thok.state = S_SSPK1
					thok.angle = ANGLE_22h*(i-1)
					P_InstaThrust(thok, thok.angle, 69*FRACUNIT)
				end	
			end
		end	
		
		if timer == 60		
			local m = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)				
			m.state = S_GOLDENHALOBEAM1
			m.scale = FRACUNIT*4
			m.color = SKINCOLOR_MAGENTA
		end
				
		if timer == 80
			DoExplosion(target)
		end	
		
		if timer == 90
			damageObject(target)
		end
		
		if timer == 115
			return true
		end	
	end,
}

attackDefs["luminous_ray"] = {
		name = "Luminous Ray",
		type = ATK_GRAVITY,	    		
		power = 350,
		accuracy = 95,
		costtype = CST_SP,
		cost = 12,
		desc = "Orbal Art\nHeavy Gravity Damage to one enemy",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer < 36
			
				if timer == 1
					playSound(mo.battlen, sfx_lumray)
				end
				local h_angle = P_RandomRange(1, 359)*ANG1
				local v_angle = P_RandomRange(1, 359)*ANG1
				local dist = 256
				local spd = P_RandomRange(40, 50)

				local s_x = mo.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
				local s_y = mo.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
				local s_z = (mo.z+mo.height/2)+ dist* sin(v_angle)

				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_WHITE
				s.scale = FRACUNIT*1
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (mo.x - s.x)/10
				s.momy = (mo.y - s.y)/10
				s.momz = (mo.z - s.z)/10
				
				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_WHITE
				s.scale = FRACUNIT*1
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (mo.x - s.x)/10
				s.momy = (mo.y - s.y)/10
				s.momz = (mo.z - s.z)/10
				
				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_WHITE
				s.scale = FRACUNIT*1
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (mo.x - s.x)/10
				s.momy = (mo.y - s.y)/10
				s.momz = (mo.z - s.z)/10
				
			elseif timer < 71
				
				P_StartQuake(FRACUNIT*50, 10)
				local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
				s.state = S_THOK
				s.tics = -1
				s.fuse = 10
				s.scale = 2*FRACUNIT
				s.color = SKINCOLOR_WHITE
				P_InstaThrust(s,(R_PointToAngle2(mo.x, mo.y, target.x, target.y)),100*FRACUNIT)
				local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
				s.state = S_THOK
				s.tics = -1
				s.fuse = 10
				s.scale = 2*FRACUNIT
				s.color = SKINCOLOR_WHITE
				P_InstaThrust(s,(R_PointToAngle2(mo.x, mo.y, target.x, target.y)),100*FRACUNIT)
				local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
				s.state = S_THOK
				s.tics = -1
				s.fuse = 10
				s.scale = 2*FRACUNIT
				s.color = SKINCOLOR_WHITE
				P_InstaThrust(s,(R_PointToAngle2(mo.x, mo.y, target.x, target.y)),100*FRACUNIT)
				
				
				
				if timer == 38
					damageObject(target)
					for k,v in ipairs(mo.allies)
						if v and v.control and v.control.valid
							P_FlashPal(v.control, 5, 10)
						end
					end
				end
			end
			if timer == 80
				return true
			end
		end,
}

attackDefs["silver_thorn"] = {
	name = "Silver Thorn",
	type = ATK_GRAVITY,
	power = 60,
	accuracy = 95,
	costtype = CST_SP,
	cost = 8,
	desc = "Orbal Art\nLight Gravity Damage to all enemies",
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)
	
		local avgx, avgy = 0, 0
		for i = 1, #hittargets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		if timer == 5
			playSound(mo.battlen, sfx_silthr)
		end	
			
		if timer > 10 and timer <= 30	
			for i = 1, 6
				local ang = (360/6 *i)*ANG1
				local c = P_SpawnMobj(avgx + 256*cos(ang), avgy + 256*sin(ang), mo.floorz - 50*FRACUNIT, MT_DUMMY)
				c.sprite = SPR_SVTH
				c.frame = A
				c.angle = ang+ANG1*90
				c.tics = 90
			end
		end	
		
		if timer == 55
			for k,v in ipairs(mo.allies)
				if v and v.control and v.control.valid
					P_FlashPal(v.control, 5, 5)
				end
			end	
		end	
		
		
		if timer >= 55 and timer < 130
			for i = 1, 2
				local m = P_SpawnMobj(avgx + P_RandomRange(-31, 31)*FRACUNIT, avgy  + P_RandomRange(-31, 31)*FRACUNIT, mo.floorz - 100*FRACUNIT, MT_DUMMY)
				m.tics = -1
				m.color = SKINCOLOR_BUBBLEGUM
				m.frame = FF_FULLBRIGHT
				m.scale = FRACUNIT*15
				m.momz = FRACUNIT*64
				m.fuse = TICRATE
				m.sprite = SPR_THOK
			end	
		end
		
		if timer == 85
			for k,v in ipairs(mo.allies)
				if v and v.control and v.control.valid
					P_FlashPal(v.control, 5, 5)
				end
			end	
		end	
		
		if timer == 130
			for i = 1, 64
				local t = P_SpawnMobj(avgx, avgy, mo.z, MT_THOK)
				t.tics = TICRATE
				t.fuse = TICRATE
				t.frame = A
				t.momx = P_RandomRange(-32, 32)*FRACUNIT
				t.momy = P_RandomRange(-32, 32)*FRACUNIT
				t.momz = P_RandomRange(-32, 32)*FRACUNIT
				t.color = P_RandomRange(0, 1) and SKINCOLOR_MAGENTA or SKINCOLOR_BUBBLEGUM
				t.scale = FRACUNIT*2
			end
		end
		
		if timer == 131
			for i = 1, #hittargets
				local target = hittargets[i]
				damageObject(target)
			end
		end
		
		if timer == 155
			return true
		end
	end,
}

attackDefs["avalon_gate"] = {
	name = "Avalon Gate",
	type = ATK_GRAVITY,	    		
	power = 140,
	accuracy = 95,
	costtype = CST_SP,
	cost = 16,
	desc = "Orbal Art\nMedium Gravity Damage to all enemies",
	target = TGT_ALLENEMIES,		
	anim = function(mo, targets, hittargets, timer)
		
		local avgx, avgy = 0, 0
		for i = 1, #hittargets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		if timer == 1
			mo.megithoks = {}
		
		elseif timer > 10 and timer <= 70
			local navgx = avgx - 128*cos(mo.angle - ANG1*0)
			local navgy = avgy - 128*sin(mo.angle - ANG1*0)
			mo.megithoks[#mo.megithoks+1] = P_SpawnMobj(navgx + P_RandomRange(-256, 256)*FRACUNIT, navgy + P_RandomRange(-256, 256)*FRACUNIT, mo.z + FRACUNIT*512, MT_DUMMY)
			local m = mo.megithoks[#mo.megithoks]
			m.state = S_MEGITHOK
			m.scale = $*2
			m.momz = -FRACUNIT*64
			P_InstaThrust(m, mo.angle - ANG1*0, 32*FRACUNIT)
        end
		
		if timer == 10
			playSound(mo.battlen, sfx_avagat)
		end	
		
		if timer == 70
            playSound(mo.battlen, sfx_megi5)
            for j = 1, 32

                local st = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
                st.state = S_MEGITHOK
                st.flags = $ & ~MF_NOGRAVITY
                st.momx = P_RandomRange(-128, 128)*FRACUNIT
                st.momy = P_RandomRange(-128, 128)*FRACUNIT
                st.momz = P_RandomRange(0, 128)*FRACUNIT
                st.fuse = TICRATE*4
                st.scale = FRACUNIT*2/3
            end
		end
		
		if timer == 70
			for i = 1, #hittargets
				local target = hittargets[i]
				damageObject(target)
			end
			
		elseif timer == 100
			mo.megithoks = nil
			return true
		end
		
		local i = #mo.megithoks
		while i
			local m = mo.megithoks[i]
			if not m or not m.valid
				table.remove(mo.megithoks, i)
				i = $-1
				continue
			end

			-- ghost trail:
			P_SpawnGhostMobj(m)

			if m.z <= m.floorz

				P_RemoveMobj(m)
				i = $-1
				continue
			end


			i = $-1
		end
	end,
}

attackDefs["claiomh_solarion"] = {
	name = "Claiomh Solarion",
	type = ATK_GRAVITY,	    		
	power = 350,
	accuracy = 95,
	costtype = CST_SP,
	cost = 24,
	desc = "Orbal Art\nHeavy Gravity Damage to all enemies",
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)
		
		local avgx, avgy = 0, 0
		for i = 1, #hittargets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		if timer == 10
			playSound(mo.battlen, sfx_clasol)
		end	
		
				
		if timer >= 10 and timer <= 90
			local cam = server.P_BattleStatus[mo.battlen].cam
			local hang = cam.angle + ANG1*90
			local vang = ANG1*P_RandomRange(1,359)
			local dist = 300
			local x, y = 0, 0
			while x > -300 and x < 300 and y > -300 and y < 300
				x = mo.x + P_RandomRange(-300, 300)*FRACUNIT
				y = mo.y + P_RandomRange(-300, 300)*FRACUNIT
			end
			local z = (mo.z + 580*FRACUNIT) + (P_RandomRange(-300,300))*FRACUNIT
			local ol = P_SpawnMobj(x, y, z, MT_THOK)
			ol.state = S_MEGITHOK
			ol.scale = FRACUNIT*1
			ol.fuse = 25
			ol.momx = $ + (avgx-ol.x)/32
			ol.momy = $ + (avgy-ol.y)/32
			ol.momz = $ + ((mo.z+580*FRACUNIT)-ol.z)/32
		end
		
		if timer == 120
			localquake(mo.battlen, FRACUNIT*10, 30)
		end	
		
		
		if timer == 160
			for k,v in ipairs(mo.allies)
				if v and v.control and v.control.valid
					P_FlashPal(v.control, 5, 2)
				end
			end
		end	
				
		if timer == 160		
			local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)				
			m.sprite = SPR_BEAM
			m.scale = FRACUNIT*10
			m.frame = D
			m.color = SKINCOLOR_WHITE
			m.tics = 5
			localquake(mo.battlen, FRACUNIT*30, 30)
		
		elseif timer == 165
			local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)				
			m.sprite = SPR_BEAM
			m.scale = FRACUNIT*10
			m.frame = C
			m.color = SKINCOLOR_WHITE
			m.tics = 5
			
		elseif timer == 170
			local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)				
			m.sprite = SPR_BEAM
			m.scale = FRACUNIT*10
			m.frame = B
			m.color = SKINCOLOR_WHITE
			m.tics = 5
			
		elseif timer == 175
			local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)				
			m.sprite = SPR_BEAM
			m.scale = FRACUNIT*10
			m.frame = A
			m.color = SKINCOLOR_WHITE
			m.tics = 5
		end
		
		
		if timer > 159 and timer < 180
			if not (leveltime%1)
				local rx = avgx + P_RandomRange(-128,128)*FRACUNIT
				local ry = avgy + P_RandomRange(-128,128)*FRACUNIT
				local t = P_SpawnMobj (rx,ry,mo.floorz,MT_THOK)
				t.state = S_ROCKCRUMBLEA
				t.scale = 3*FRACUNIT
				t.momz = (P_RandomRange(8,64)/2)*FRACUNIT
				t.fuse = 105
			end
		end
		
		
		if timer == 160
            playSound(mo.battlen, sfx_megi5)
            for j = 1, 32
                local st = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
                st.state = S_MEGITHOK
                st.flags = $ & ~MF_NOGRAVITY
                st.momx = P_RandomRange(-128, 128)*FRACUNIT
                st.momy = P_RandomRange(-128, 128)*FRACUNIT
                st.momz = P_RandomRange(0, 128)*FRACUNIT
                st.fuse = TICRATE*4
                st.scale = FRACUNIT*3/5
            end
		end

			
		if timer == 161
			for i = 1, #hittargets
				local target = hittargets[i]
				damageObject(target)
			end
		
		elseif timer == 190
			return true
		end
	end,	
}

attackDefs["last_disaster"] = {
	name = "Last Disaster",
	type = ATK_GRAVITY,	    		
	power = 600,
	accuracy = 95,
	costtype = CST_SP,
	cost = 40,
	desc = "Orbal Art\nSevere Gravity Damage to one enemy",
	target = TGT_ENEMY,
			hudfunc = 	function(v, mo, timer)
						
						if timer > 190
						and timer < 200
							local t = timer-190
							local p = "H_ATR"..t/2
							if v.patchExists(p)
								drawScreenwidePatch(v, v.cachePatch(p))
							end
						end
					end,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		local psiocolors = {SKINCOLOR_GREY, SKINCOLOR_CLOUDY, SKINCOLOR_BONE, SKINCOLOR_WHITE}
		
		if timer > 1 and timer < 25
			localquake(mo.battlen, FRACUNIT*10, 30)
			if not (leveltime%5)
				local rx = target.x + P_RandomRange(-128,128)*FRACUNIT
				local ry = target.y + P_RandomRange(-128,128)*FRACUNIT
				local t = P_SpawnMobj(rx, ry, target.z, MT_THOK)
				t.state = S_BRICKDEBRIS
				t.scale = FRACUNIT*2
				t.momz = (P_RandomRange(4,64)/2)*FRACUNIT
				t.fuse = 75
			end
		end
		
		if timer == 15
			playSound(mo.battlen, sfx_latdis)
		end	

		
		if timer >= 20 and timer <= 55
			if timer == 20
				playSound(mo.battlen, sfx_s3k74)
			end
			if not (timer%4)

				local ol = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				ol.sprite = SPR_NTHK
				ol.color = psiocolors[P_RandomRange(1, #psiocolors)]
				ol.scale = 1
				ol.destscale = FRACUNIT*32
				ol.scalespeed = FRACUNIT/5
				ol.frame = B|FF_FULLBRIGHT
				ol.tics = 20

				ol = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				ol.sprite = SPR_NTHK
				ol.color = psiocolors[P_RandomRange(1, #psiocolors)]
				ol.scale = 1
				ol.destscale = FRACUNIT*32
				ol.scalespeed = FRACUNIT
				ol.frame = B|FF_FULLBRIGHT|TR_TRANS50
				ol.tics = 8
			end
		end	
		
		if timer == 25 
			localquake(mo.battlen, FRACUNIT*25, 10)
		end
		
		if timer == 45 
			localquake(mo.battlen, FRACUNIT*25, 10)
		end
		
		
		if timer == 80
			DoExplosion(target)
		end
		
		if timer >= 85 and timer <= 230
			for i = 1, 2
				local m = P_SpawnMobj(target.x + P_RandomRange(-64, 64)*FRACUNIT, target.y  + P_RandomRange(-64, 64)*FRACUNIT, target.z, MT_DUMMY)
				m.tics = -1
				m.color = SKINCOLOR_WHITE
				m.frame = FF_FULLBRIGHT
				m.scale = FRACUNIT*2
				m.momz = FRACUNIT*64
				m.fuse = TICRATE
				m.sprite = SPR_THOK
			end	
		end
		
		if timer > 85 and timer < 230
			localquake(mo.battlen, FRACUNIT*50, 75)
			if not (leveltime%5)
				local rx = target.x + P_RandomRange(-128,128)*FRACUNIT
				local ry = target.y + P_RandomRange(-128,128)*FRACUNIT
				local t = P_SpawnMobj(rx, ry, target.z, MT_THOK)
				t.state = S_ROCKCRUMBLEA
				t.colorized = true
				t.color = SKINCOLOR_CARBON
				t.scale = 2*FRACUNIT
				t.momz = (P_RandomRange(4,64)/2)*FRACUNIT
				t.fuse = 75
			end
		end
		
		if timer == 231
			damageObject(target)
			playSound(mo.battlen, sfx_s3k83)
			
		elseif timer == 250
			return true
		end	
	end,					
}