freeslot("SPR_LOAE", "sfx_loaded", "sfx_loacrt", "S_HALOBOMB", "sfx_utstr", "sfx_golhal", "sfx_golhl2")


BTL_challengebtllist[#BTL_challengebtllist+1] = {
  name = "A Mighty Power",
  description = {"A Great Power wants", "to see your strength..."},
  level = 99,
  music = "GREPWR",
  time = TICRATE*60*55,
  items = {{"tearalbalm", 50}, {"spcharge3", 50}, {"curiabalm", 30}, {"recuriabalm", 20}, {"revbalm", 30}, {"celbalm", 20}, {"hypercombiring", 30}, {"soma", 5}},
  waves = {
			{"loa"},
		},
}


enemyList["loa"] = {
		name = "Loa Erebonius",
		skillchance = 100,	
		level = 100,
		hp = 10000,
		sp = 9999,
		strength = 80,
		magic = 80,
		endurance = 60,
		luck = 70,
		agility = 72,
		melee_natk = "clawstrike",	
		thinker = generalEnemyThinker,
		scale = FRACUNIT*2,
		boss = true,
		endboss = true,
		turns = 2,

		anim_stand = 		{SPR_LOAE, A, 4},				-- standing
		anim_stand_hurt =	{SPR_LOAE, A, 4},					-- standing (low HP) *
		anim_stand_bored =	{SPR_LOAE, A, 4},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_LOAE, A, 4},				-- guarding
		anim_move =			{SPR_LOAE, A, 4},	-- moving
		anim_run =			{SPR_LOAE, A, 4},	-- guess what
		anim_atk =			{SPR_LOAE, A, 4},			-- attacking
		anim_aoa_end =		{SPR_LOAE, A, 4},			-- jumping out of all-out attack
		anim_hurt =			{SPR_LOAE, A, 4},				-- taking damage
		anim_getdown =		{SPR_LOAE, A, 4},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_LOAE, A, 4},					-- is down
		anim_getup =		{SPR_LOAE, A, 4},			-- gets up from down
		anim_death =		{SPR_LOAE, A, 4},					-- dies
		anim_revive =		{SPR_LOAE, A, 4},			-- gets revived
		anim_evoker =		{SPR_LOAE, A, 4},
		anim_evoker_shoot = {SPR_LOAE, A, 4},
		
		vfx_crit = {"sfx_loacrt"},
		
		hudcutin = "LOAE_A",	-- cut in

		
		skills = {"garkuti", "finaltrialmap", "blesatu", "kilati", "jukait", "fors", "clawstrike", "vel-da-doop", "vilna-ya", "ark-zok-onkeim", "volzello-anaia", "van-ku-oh", "dekakunda", "calamitous_blast", "golden halo", "sol_eruption"},
		
		deathanim = function(mo)

						mo.deathtimer = $ and $+1 or 1

						if mo.deathtimer == 1
							for p in players.iterate do
								if p and p.control and p.control.valid and p.control.battlen == mo.battlen
									S_FadeOutStopMusic(200, p)
								end
							end
							
							mo.basecoords = {mo.x, mo.y, mo.z}
							mo.flags = $|MF_NOCLIPHEIGHT|MF_NOGRAVITY							

						elseif mo.deathtimer == 20 
							S_StartSound(nil, sfx_loaded)
						end	
							
						if mo.deathtimer > 20
						and mo.deathtimer < 220

							if leveltime & 1
								for i = 1, 2

									local s = P_SpawnMobj(mo.x, mo.y, mo.z + mo.scale*32, MT_DUMMY)
									if i == 1
										s.z = $ - mo.scale*32
									else
										s.z = $ + mo.scale*100
									end

									s.sprite = SPR_SLAS
									s.frame = K+(i-1) | FF_FULLBRIGHT | TR_TRANS30
									s.color = SKINCOLOR_MAGENTA
									s.scale = FRACUNIT/8
									s.destscale = FRACUNIT*20
									s.scalespeed = FRACUNIT/2
									s.tics = TICRATE/2

									s.momx = P_RandomRange(-2, 2)*FRACUNIT
									s.momy = P_RandomRange(-2, 2)*FRACUNIT
									s.momz = P_RandomRange(-2, 2)*FRACUNIT

								end
							end	
						end	
									
						if mo.deathtimer >= 20 and mo.deathtimer <= 220
							if not (mo.deathtimer%4)
								local s = P_SpawnMobj(mo.x, mo.y, mo.z + FRACUNIT*15, MT_DUMMY)
								s.color = SKINCOLOR_WHITE
								s.flags = MF_NOBLOCKMAP
								s.state = S_MEGISTAR1
								s.scale = FRACUNIT*10
								localquake(mo.battlen, FRACUNIT*10, 20)
							end	
						end	
									
						if mo.deathtimer >= 20 and mo.deathtimer <= 200
							local baseangle = P_RandomRange(1, 360)*ANG1
							local dist = 180
							for i = 0, 24
								local angle = baseangle + i*6*ANG1
								local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)
								local aura = P_SpawnMobj(x, y, mo.z + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
								aura.state = S_AURA1
								aura.angle = angle - ANGLE_90
								aura.color = SKINCOLOR_MAGENTA
								aura.momz = P_RandomRange(2, 16)*FRACUNIT
								aura.scale = FRACUNIT*1
								aura.destscale = FRACUNIT*11
								P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(3, 9))
							end	
						end	
									
						if mo.deathtimer >= 20 and mo.deathtimer <= 220
							if not (mo.deathtimer%4)
								local ol = P_SpawnMobj(mo.x + P_RandomRange(-200, 200)*FRACUNIT, mo.y + P_RandomRange(-200, 200)*FRACUNIT, mo.z + P_RandomRange(0, 200)<<FRACBITS, MT_DUMMY)
								ol.sprite = SPR_THOK
								ol.color = SKINCOLOR_MAGENTA
								ol.scale = 1
								ol.destscale = FRACUNIT*10
								ol.scalespeed = FRACUNIT/5
								ol.frame = A|FF_FULLBRIGHT
								ol.tics = 20

								ol = P_SpawnMobj(mo.x + P_RandomRange(-200, 200)*FRACUNIT, mo.y + P_RandomRange(-200, 200)*FRACUNIT, mo.z + P_RandomRange(0, 200)<<FRACBITS, MT_DUMMY)
								ol.sprite = SPR_THOK
								ol.color = SKINCOLOR_MAGENTA
								ol.scale = 1
								ol.destscale = FRACUNIT*20
								ol.scalespeed = FRACUNIT
								ol.frame = A|FF_FULLBRIGHT|TR_TRANS50
								ol.tics = 8	
							end	
						end	
						
						if mo.deathtimer == 190
							mo.flags2 = $|MF2_DONTDRAW	
							for p in players.iterate do
								if p and p.control and p.control.valid and p.control.battlen == mo.battlen
									P_FlashPal(p, 5, 20)
								end
							end
						end	

						if mo.deathtimer == 270
							mo.deathanim = nil
							return	-- deref
						end
					end,

}

attackDefs["clawstrike"] = {
		name = "Claw Strike",
		type = ATK_SLASH,
		power = 400,
		accuracy = 90,
		costtype = CST_SP,
		cost = 48,
		critical = 2,
		technical = COND_FEAR,
		desc = "Heavy slash damage to \nall enemies.\nHeal for 5%",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			local cam = server.P_BattleStatus[mo.battlen].cam
			if timer == 1
				mo.totdam = 0
			end

			for i = 1, #hittargets
				local color = SKINCOLOR_BLACK
				local target = hittargets[i]
				local time = timer - (i-1)*6

				if time == 1
					target.rolls = {}

				elseif time == 15
				or time == 20
				or time == 25	-- lazy
					local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					s.state = S_SLASHING_2_1
					s.color = color
					s.scale = FRACUNIT*3
					playSound(mo.battlen, sfx_slash)
					s.rollangle = P_RandomRange(0, 359)*ANG1
					target.rolls[#target.rolls+1] = s.rollangle

				elseif time == 17
				or time == 22
				or time == 27

					if time == 22
					and not (i%2)

						local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
						d.sprite = SPR_THMP
						d.frame = C|FF_FULLBRIGHT
						d.scale = FRACUNIT/4
						d.destscale = FRACUNIT*3
						d.scalespeed = FRACUNIT/8
						d.fuse = TICRATE-10
						d.tics = d.fuse
						d.momz = FRACUNIT*2
						d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
						d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
						d.color = color
					end

				elseif time == 19
				or time == 24
				or time == 29

					if time == 24
						damageObject(target)
						mo.totdam = $1+target.damagetaken
						playSound(mo.battlen, sfx_bexpld)
						if not target.plyr
							createSplat(mo)
							createSplat(mo)
						end
						localquake(mo.battlen, FRACUNIT*10, 10)
					end

					local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = I|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.destscale = FRACUNIT*4
					s.scalespeed = FRACUNIT/3
					s.color = color

					s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = G|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.tics = TICRATE/2
					s.fuse = s.tics
					s.destscale = FRACUNIT*10
					s.scalespeed = FRACUNIT/4
					s.color = color
					s.rollangle = target.rolls[#target.rolls]
				end
			end

			if timer == 55 + (#hittargets-1)*6
				local cx = mo.x + 256*cos(mo.angle)
				local cy = mo.y + 256*sin(mo.angle)
				mo.atk_attacker = mo
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				ANIM_set(mo, mo.guard, true)
				playSound(mo.battlen, sfx_heal3)
				damageObject(mo, -(mo.totdam/4), DMG_NORMAL)
			elseif timer == 80 + 6*(#hittargets-1)
				mo.totdam = nil
				return true
			end
		end,
		critanim = function(mo, targets, hittargets, timer)
			local cam = server.P_BattleStatus[mo.battlen].cam
			if timer == 1
				mo.totdam = 0
			end

			for i = 1, #hittargets
				local color = SKINCOLOR_BLACK
				local target = hittargets[i]
				local time = timer - (i-1)*6

				if time == 1
					target.rolls = {}

				elseif time == 15
				or time == 20
				or time == 25	-- lazy
					local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					s.state = S_SLASHING_2_1
					s.color = color
					s.scale = FRACUNIT*3
					playSound(mo.battlen, sfx_slash)
					s.rollangle = P_RandomRange(0, 359)*ANG1
					target.rolls[#target.rolls+1] = s.rollangle

				elseif time == 17
				or time == 22
				or time == 27

					if time == 22
					and not (i%2)

						local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
						d.sprite = SPR_THMP
						d.frame = C|FF_FULLBRIGHT
						d.scale = FRACUNIT/4
						d.destscale = FRACUNIT*3
						d.scalespeed = FRACUNIT/8
						d.fuse = TICRATE-10
						d.tics = d.fuse
						d.momz = FRACUNIT*2
						d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
						d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
						d.color = color
					end

				elseif time == 19
				or time == 24
				or time == 29

					if time == 24
						damageObject(target)
						mo.totdam = $1+target.damagetaken
						playSound(mo.battlen, sfx_bexpld)
						if not target.plyr
							createSplat(mo)
							createSplat(mo)
						end
						localquake(mo.battlen, FRACUNIT*10, 10)
					end

					local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = I|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.destscale = FRACUNIT*4
					s.scalespeed = FRACUNIT/3
					s.color = color

					s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = G|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.tics = TICRATE/2
					s.fuse = s.tics
					s.destscale = FRACUNIT*10
					s.scalespeed = FRACUNIT/4
					s.color = color
					s.rollangle = target.rolls[#target.rolls]
				end
			end

			if timer == 55 + (#hittargets-1)*6
				local cx = mo.x + 256*cos(mo.angle)
				local cy = mo.y + 256*sin(mo.angle)
				mo.atk_attacker = mo
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				ANIM_set(mo, mo.guard, true)
				playSound(mo.battlen, sfx_heal4)
				damageObject(mo, -(mo.totdam/2), DMG_NORMAL)
			elseif timer == 80 + 6*(#hittargets-1)
				mo.totdam = nil
				return true
			end
		end,
}

attackDefs["vel-da-doop"] = {
		name = "Vel-da-doop",
		type = ATK_ALMIGHTY,
		power = 300,
		accuracy = 90,
		costtype = CST_SP,
		status = COND_SLEEP,
		statuschance = 20,
		cost = 30,
		desc = "Almighty Damage to all enemies.\nVery high odds of Sleep",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)

			if timer == 10
				mo.dbs = {}
				playSound(mo.battlen, sfx_cboom)
				-- ready smoke table
			end

			-- spawn said smoke:
			if timer >= 10 and timer <= TICRATE + TICRATE/2
			and mo.dbs

				for i = 1, 8
					local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					s.state = S_CDUST1
					s.color = SKINCOLOR_BLACK
					s.angle = P_RandomRange(0, 359)*ANG1
					s.scale = FRACUNIT*3
					s.scalespeed = FRACUNIT/6
					s.destscale = FRACUNIT*12
					s.dist = 0
					s.tics = 18
					mo.dbs[#mo.dbs+1] = s
				end
			end

			-- rotate the smoke
			if mo.dbs and #mo.dbs
				for i = 1, #mo.dbs do
					local s = mo.dbs[i]
					if not s or not s.valid continue end	-- don't care

					s.angle = $+ ANG1*10
					s.dist = min(1024, $+32)

					P_TeleportMove(s, mo.x + s.dist *cos(s.angle), mo.y + s.dist*sin(s.angle), s.floorz)

					if not P_RandomRange(0, 30)
						local t = P_SpawnMobj(s.x, s.y, s.z, MT_THOK)
						t.color = SKINCOLOR_BLACK
						t.frame = $|FF_FULLBRIGHT
						t.momz = P_RandomRange(4, 8)*FRACUNIT
						t.destscale = 1
						t.tics = TICRATE
					end
				end
			end

			-- hit targets
			for i = 1, #hittargets
				local target = hittargets[i]
				local t = timer - 6*(i-1)

				if t == TICRATE - TICRATE/4
					local dmg = max(1, target.hp/4)
					if target.boss
						dmg = nil
					end

					damageObject(target)
				end
			end

			if timer == TICRATE*2 - TICRATE/4 + (#hittargets-1)*6
				return true
			end
		end,
}

attackDefs["volzello-anaia"] = {
		name = "Volzello-anaia",
		type = ATK_ALMIGHTY,
		power = 1550,
		accuracy = 90,
		costtype = CST_SP,
		cost = 30,
		critical = 2,
		desc = "Almighty Damage to all enemies.\nDoes a lot of damage",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)

				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				-- average position of the enemies

				if timer == 10
					playSound(mo.battlen, sfx_megi3)

					-- get them cards ready

					-- first row
					mo.hcard = {}
					for i = 1, 6
						local ang = (360/6 *i)*ANG1
						local c = P_SpawnMobj(avgx + 256*cos(ang), avgy + 256*sin(ang), mo.z, MT_DUMMY)
						c.sprite = SPR_THOK
						c.frame = A|FF_FULLBRIGHT
						c.color = SKINCOLOR_BLACK
						c.scale = 1
						c.destscale = FRACUNIT*5
						c.scalespeed = (FRACUNIT*5)/80
						c.angle = ang+ANG1*90
						c.tics = -1
						mo.hcard[#mo.hcard+1] = c
					end
				elseif timer == 20
					-- get them cards ready

					-- first row
					mo.hcard2 = {}
					for i = 1, 10
						local ang = (360/10 *i)*ANG1
						local c = P_SpawnMobj(avgx + 320*cos(ang), avgy + 320*sin(ang), mo.z, MT_DUMMY)
						c.sprite = SPR_THOK
						c.frame = A|FF_FULLBRIGHT
						c.color = SKINCOLOR_WHITE
						c.angle = ang+ANG1*90
						c.tics = -1
						c.scale = 1
						c.destscale = FRACUNIT*5
						c.scalespeed = (FRACUNIT*5)/80
						mo.hcard2[#mo.hcard2+1] = c
					end
				end

				local ct = mo.hcard
				while ct

					for i = 1, #ct
						local c = ct[i]

						if c.appeartimer == nil
							c.appeartimer = 9
						end
						c.frame = A|FF_FULLBRIGHT|FF_PAPERSPRITE | (c.appeartimer<<FF_TRANSSHIFT)
						c.appeartimer = max(4, $-1)

						if timer >= TICRATE*3/2
						and leveltime & 1
							c.frame = A|FF_FULLBRIGHT|FF_PAPERSPRITE
						end

						if c.appeartimer <= 4

							c.rspeed = $ or 1
							if leveltime%4 == 0
								c.rspeed = min(25, $+1)
							end

							if ct == mo.hcard2
								c.angle = $ + c.rspeed*ANG1
							else
								c.angle = $ - c.rspeed*ANG1
							end	-- rotate

							--update pos

							if leveltime & 1
								local g = P_SpawnGhostMobj(c)
								g.fuse = 2
							end

							local dist = ct == mo.hcard2 and 320 or 256
							P_TeleportMove(c, avgx + dist*cos(c.angle - ANG1*90), avgy + dist*sin(c.angle - ANG1*90), c.z)
						end

						if timer == TICRATE*5/2
							P_InstaThrust(c, c.angle - ANG1*90, 48*FRACUNIT)
							c.fuse = TICRATE
						end
					end


					-- fuck you
					if ct == mo.hcard2
						break
					else
						ct = mo.hcard2
					end
				end

				if timer >= 20

					if timer == TICRATE
						playSound(mo.battlen, sfx_zio5)
					end

					local baseangle = P_RandomRange(1, 360)*ANG1
					local dist = 256
					for i = 0, 24
						local angle = baseangle + i*6*ANG1
						local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, mo.z + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = SKINCOLOR_WHITE
						aura.momz = P_RandomRange(4, 16)*FRACUNIT
						aura.scale = FRACUNIT*2
						aura.destscale = FRACUNIT*5
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(3, 9))
					end
				end

				if timer == TICRATE*5/2
					mo.hcard = nil
					mo.hcard2 = nil

					playSound(mo.battlen, sfx_tiexp)

					for k,v in ipairs(hittargets)
						damageObject(v)
					end
				end

				if timer >= TICRATE*5/2
				and timer <= TICRATE*4

					for i = 1, 16
						local boom = P_SpawnMobj(avgx + P_RandomRange(-48, 48)*FRACUNIT, avgy + P_RandomRange(-48, 48)*FRACUNIT, mo.z, MT_SUPERSPARK)
						boom.momz = P_RandomRange(16, 64)*FRACUNIT
						boom.scale = FRACUNIT*2
					end
				end

				if timer == TICRATE*4
					return true
				end
		end,
}

attackDefs["van-ku-oh"] = {
		name = "Van-ku-oh",
		type = ATK_ALMIGHTY,
		costtype = CST_SP,
		cost = 24,
		desc = "Severe Almighty damage to\nall enemies.",
		target = TGT_ALLENEMIES,
		critical = 2,
		accuracy = 100,
		power = 750,
		anim = 			function(mo, targets, hittargets, timer)

							local avgx = 0
							local avgy = 0

							for i = 1, #hittargets
								local t = hittargets[i]

								avgx = $+ t.x/FRACUNIT
								avgy = $+ t.y/FRACUNIT

								local time = timer - 10*(i-1)

								if time >= 20 and time <= 30
								and (time%5) == 0

									local s = P_SpawnMobj(t.x + P_RandomRange(-128, 128)<<FRACBITS, t.y + P_RandomRange(-128, 128)<<FRACBITS, t.z + P_RandomRange(0, 192)<<FRACBITS, MT_DUMMY)
									s.color = SKINCOLOR_BLACK
									s.state = S_MEGISTAR1
									s.scale = $*2 + P_RandomRange(0, 65535)
									playSound(mo.battlen, sfx_hamas1)
								end
							end

							if timer == 40 + 10*(#hittargets-1)
								-- get average coords from what we had before
								avgx = ($/ #hittargets)*FRACUNIT
								avgy = ($/ #hittargets)*FRACUNIT

								local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*128, MT_DUMMY)
								s.color = SKINCOLOR_BLACK
								s.state = S_MEGISTAR1
								s.scale = FRACUNIT*4
								playSound(mo.battlen, sfx_hamas2)
							elseif timer == 50 + 10*(#hittargets-1)
								-- explode lol
								playSound(mo.battlen, sfx_megi6)
								avgx = ($/ #hittargets)*FRACUNIT
								avgy = ($/ #hittargets)*FRACUNIT
								local an = 0
								for i = 1, 32

									local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
									s.color = SKINCOLOR_BLACK
									s.state = S_CDUST1
									s.scale = FRACUNIT*4
									s.fuse = TICRATE*3
									P_InstaThrust(s, an*ANG1, 50<<FRACBITS)

									s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
									s.color = SKINCOLOR_BLACK
									s.state = S_CDUST1
									s.scale = FRACUNIT*4
									s.fuse = TICRATE*3
									P_InstaThrust(s, an*ANG1, 30<<FRACBITS)

									an = $ + (360/32)
								end

								for i = 1, #hittargets do
									damageObject(hittargets[i])
								end
							elseif timer == 100 + 10*(#hittargets-1)
								return true
							end
						end

}

attackDefs["ark-zok-onkeim"] = {
		name = "Ark-zok-onkeim",
		type = ATK_ALMIGHTY,
		power = 1000,
		accuracy = 999,
		costtype = CST_SP,
		cost = 16,
		status = COND_FREEZE,
		statuschance = 100,
		desc = "Drains a Enemy's HP and Insta Freezes it",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
					local target = hittargets[1]

					if timer >= 20 and timer <= 40

						if timer == 20
							playSound(mo.battlen, sfx_endrn)
                        elseif timer == 30
                            damageObject(target, target.maxhp/10)
                            mo.buf_damage = target.damagetaken*5
                        end

						for i = 1,2
							local thok = P_SpawnMobj(target.x, target.y, target.z+mo.height/2, MT_DUMMY)
							thok.color = SKINCOLOR_PERIDOT
							thok.momx = P_RandomRange(-10, 10)*FRACUNIT
							thok.momy = P_RandomRange(-10, 10)*FRACUNIT
							thok.momz = P_RandomRange(-10, 10)*FRACUNIT
							thok.scale = FRACUNIT/10
							thok.destscale = FRACUNIT*2
						end

					elseif timer >= 50 and timer <= 70

						if timer == 60
						and target ~= mo
							mo.atk_attacker = mo
							playSound(mo.battlen, sfx_lsheal)
							damageObject(mo, -mo.buf_damage, DMG_NORMAL)
						end

						local h_angle = P_RandomRange(1, 359)*ANG1
						local v_angle = P_RandomRange(1, 359)*ANG1
						local dist = 256
						local spd = P_RandomRange(40, 50)

						local s_x = mo.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
						local s_y = mo.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
						local s_z = (mo.z+mo.height/2)+ dist* sin(v_angle)

						local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

						s.frame = A
						s.color = SKINCOLOR_CYAN
						s.scale = FRACUNIT*3/2
						s.destscale = FRACUNIT/5
						s.target = target
						s.tics = 10
						s.momx = (mo.x - s.x)/10
						s.momy = (mo.y - s.y)/10
						s.momz = (mo.z - s.z)/10

					elseif timer == 110
						return true
					end
				end,
}

attackDefs["vilna-ya"] = {
		name = "Vilna-ya",
		type = ATK_ALMIGHTY,
		power = 850,
		accuracy = 90,
		costtype = CST_SP,
		cost = 24,
		desc = "Severe Almighty damage\n to all enemies.",
		target = TGT_ALLENEMIES,
		critical = 2,
		anim = function(mo, targets, hittargets, timer)

			local MYFUCKINGEARS

			for k,v in ipairs(hittargets)

				local target = v
				local time = timer - 6*(k-1)

				if time >= 20 and time <= 40

					if leveltime%3 == 0
						local thok = P_SpawnMobj(target.x + P_RandomRange(-200, 200)*FRACUNIT, target.y + P_RandomRange(-200, 200)*FRACUNIT, target.z + P_RandomRange(0, 200)<<FRACBITS, MT_DUMMY)
						thok.scale = FRACUNIT*3/2
						A_OldRingExplode(thok, MT_SUPERSPARK)
						thok.flags2 = $|MF2_DONTDRAW
						if not MYFUCKINGEARS
							playSound(mo.battlen, sfx_bufu3)
						end
						MYFUCKINGEARS = true

						local speeds = {FRACUNIT/16, FRACUNIT/10, FRACUNIT/3, FRACUNIT/8}
						local fuses = {20, 16, 8, 16}

						for i = 1, 2
							local l = P_SpawnMobj(thok.x, thok.y, thok.z + FRACUNIT*32, MT_THOK)	-- mt_thok for auto fadeout
							l.tics = -1
							l.sprite = SPR_CARD
							l.color = SKINCOLOR_WHITE
							l.frame = L|(i== 2 and TR_TRANS40 or TR_TRANS70)|FF_FULLBRIGHT
							l.scale = FRACUNIT/2
							l.destscale = FRACUNIT*6
							l.scalespeed = speeds[i]
							l.fuse = fuses[i]
						end

					end

					if time == 35
						damageObject(target)
					end
					for i = 1,8
						local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
						thok.state = S_SSPK1
						thok.momz = P_RandomRange(15, 30)*FRACUNIT
						thok.momx = P_RandomRange(-6, 6)*FRACUNIT
						thok.momy = P_RandomRange(-6, 6)*FRACUNIT
					end
				end
			end

			if timer == 60 + 6*(#hittargets-1)
				return true
			end
		end,
}

attackDefs["fors"] = {
		name = "Fors-yokin",
		type = ATK_PASSIVE|ATK_ALMIGHTY,
		desc = "Boost Almighty damage by 20%",
		power = 20,
		passive = PSV_BOOST,
}

attackDefs["kilati"] = {
		name = "Kilati",
		type = ATK_PASSIVE|ATK_CURSE,
		desc = "Boost Curse damage by 20%",
		power = 20,
		passive = PSV_BOOST,
}

attackDefs["blesatu"] = {
		name = "Blesatu",
		type = ATK_PASSIVE|ATK_BLESS,
		desc = "Boost Bless damage by 20%",
		power = 20,
		passive = PSV_BOOST,
}

attackDefs["jukait"] = {
		name = "Jukait",
		type = ATK_PASSIVE|ATK_SLASH,
		desc = "Boost Slash damage by 20%",
		power = 20,
		passive = PSV_BOOST,
}

attackDefs["golden halo"] = {
	name = "Golden Halo",
	type = ATK_BLESS,
	power = 710,
	accuracy = 95,
	costtype = CST_SP,
	cost = 32,
	desc = "Orbal Art\nSevere Bless damage to \nall enemies.",
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)
		
		local avgx, avgy = 0, 0
		for i = 1, #hittargets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		
		
		if timer == 1
			mo.megi = {}
			mo.flair = {}
			mo.alphabeam = {}
		
		elseif timer >= 24 and timer < 80 and timer%4 == 0
			local megi
			local dist = P_RandomRange(-400,400)
			while dist <= 300 and dist >= -300
				dist = P_RandomRange(-400,400)
			end
			local ang = P_RandomRange(0, 359)*ANG1
			playSound(mo.battlen, sfx_s3k74)
			megi = P_SpawnMobj(avgx + dist*cos(ang), avgy + dist*sin(ang), mo.z + P_RandomRange(100, 400)*FRACUNIT, MT_DUMMY)
			megi.state = S_HALOBOMB
			megi.angle = ang
			megi.dist = dist
			megi.dismom = 1
			megi.color = SKINCOLOR_GOLD
			megi.fuse = 120 - timer
			megi.scale = FRACUNIT
			megi.extravalue1 = 1
			mo.megi[#mo.megi+1] = megi
			local g = P_SpawnMobj(avgx, avgy, mo.z + P_RandomRange(70, 400)*FRACUNIT, MT_HTRAIL)
			local step = P_RandomRange(1,10)
			g.angle = FixedAngle(P_RandomRange(1, 360)*FRACUNIT)
			if step == 2
				g.jizzcolor = true
			end
			g.frame = A|FF_FULLBRIGHT|TR_TRANS30
			g.sx = avgx
			g.sy = avgy
			g.dist = P_RandomRange(-400, 400)
			g.tics = 120 - timer
			g.lowquality = true
		
		elseif timer == 120
			for k,v in ipairs(mo.allies)
				if v and v.control and v.control.valid
					P_StartQuake(FRACUNIT*17, 20)
					P_FlashPal(v.control, 1, 10) //v.control, pallette, tics active, 5 is the inverted palette, 4 is the Arma's red flash pal, rest are just white flash excl 0
				end
			end
			for k,v in ipairs(mo.enemies)
				if v and v.control and v.control.valid
					P_StartQuake(FRACUNIT*17, 20)
					P_FlashPal(v.control, 1, 10) //v.control, pallette, tics active, 5 is the inverted palette, 4 is the Arma's red flash pal, rest are just white flash excl 0
				end
			end
			for i = 1, 5
				local beam = P_SpawnMobj(avgx, avgy, mo.z+(3+100*(i-1))*FRACUNIT, MT_DUMMY)
				beam.sprite = SPR_BEAM
				beam.frame = C|FF_FULLBRIGHT
				beam.color = SKINCOLOR_GOLD
				beam.scale = FRACUNIT*2
				beam.tics = 30
				beam.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				mo.alphabeam[#mo.alphabeam+1] = beam
			end
			for j = 1, 96
				local st = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
				st.state = S_MEGITHOK
				st.flags = $ & ~MF_NOGRAVITY
				st.momx = P_RandomRange(-128, 128)*FRACUNIT
				st.momy = P_RandomRange(-128, 128)*FRACUNIT
				st.momz = P_RandomRange(0, 128)*FRACUNIT
				st.fuse = TICRATE*4
				st.scale = FRACUNIT*2/3
			end
			for i = 1, #hittargets
				local target = hittargets[i]
				damageObject(target)
			end
		elseif timer == 140 or timer == 145
			for i = 1, 5
				local beam = mo.alphabeam[i]
				beam.frame = timer == 140 and B|FF_FULLBRIGHT or A|FF_FULLBRIGHT
			end
		elseif timer == 170
			return true
		end
		
		if timer == 1
			playSound(mo.battlen, sfx_golhal)
		end	
		
		if timer == 101
			playSound(mo.battlen, sfx_utstr)
		end
		
		if timer == 120
			playSound(mo.battlen, sfx_golhl2)
		end	
		
		local j = #mo.megi
		while j
			local h = mo.megi[j]
			if not h or not h.valid
				table.remove(mo.megi, j)
				j = $-1
				continue
			end
			
			if timer <= 100
				
				if h.dismom < 10 and timer <= 80
					h.dismom = $ + 1
					h.dist = $ + 10
				elseif timer > 90
					h.dismom = $ - 1
				end
				
				h.angle = $ + h.dismom*ANG1
				P_TeleportMove(h, avgx + h.dist*cos(h.angle), avgy + h.dist*sin(h.angle), h.z)
			elseif timer > 100 and timer < 120
				h.momx = $ + (avgx-h.x)/128
				h.momy = $ + (avgy-h.y)/128
				h.momz = $ + (mo.z-h.z)/128
			end
			
			j = $ - 1
		end
	end,
	}

attackDefs["calamitous_blast"] = {
	name = "Calamitous Blast",
	type = ATK_CURSE,
	power = 700,
	accuracy = 95,
	costtype = CST_SP,
	cost = 24,
	desc = "Orbal Art\nSevere curse damage to all enemies.",
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)
		
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		if timer == 10
			playSound(mo.battlen, sfx_eih1)
			local firebol = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*256, MT_DUMMY)
			firebol.scale = 1 
			firebol.tics = 100
			firebol.destscale = FRACUNIT*3 
			firebol.sprite = SPR_THOK
			firebol.color = SKINCOLOR_MAGENTA
			firebol.frame = A|FF_TRANS20
			firebol.scalespeed = (FRACUNIT*6)/80
		end
		
		if timer >= 30 and timer <= 100
			local orb = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*256, MT_DUMMY)
			orb.sprite = SPR_DELK
			orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
			orb.color = SKINCOLOR_FLAME
			orb.destscale = FRACUNIT*7
			orb.scalespeed = FRACUNIT/4
			orb.tics = TICRATE/8
			localquake(mo.battlen, FRACUNIT*10, 10)
		end	
		
		if timer >= 30 and timer <= 100
			local range = 1024
			local z2 = P_SpawnMobj(avgx + P_RandomRange(-range, range)*mo.scale, avgy + P_RandomRange(-range, range)*mo.scale, mo.z, MT_DUMMY)
			z2.state, z2.scale, z2.color = S_NZIO21, FRACUNIT*4, SKINCOLOR_FLAME
			z2.destscale = FRACUNIT*1
		end
		
		if timer >= 30 and timer <= 100
			if leveltime%8 == 0
				playSound(mo.battlen, sfx_zio2)
			end	
		end	
		
		if timer == 101
			for i = 1,#hittargets -- damageObject must be used on all enemies individually.
				local target = hittargets[i]
				darkzio(target, SKINCOLOR_FLAME, FRACUNIT*3/2)
				damageObject(target)
			end	
		end	
		
		if timer == 120
			return true
		end
	end,


}

attackDefs["sol_eruption"] = {
		name = "Sol Eruption",
		type = ATK_ALMIGHTY,
		power = 710,
		accuracy = 90,
		critical = 1,
		target = TGT_ALLENEMIES,
		costtype = CST_SP,
		cost = 150,
		desc = "Lost Art.\nSevere Almighty Damage to all enemies.",
		anim_norepel = true,	-- do not bounce back our ANIMATION
		anim = function(mo, targets, hittargets, timer)
			local target = targets[1]
			
			mo.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
			
			if timer == 5
				S_StartSound(nil,sfx_s3k53)
			end
			
			if timer == 230
				S_StartSound(nil,sfx_tiexp)
			end	

			if timer < 105
				mo.momz = FRACUNIT
			else
				mo.momz = 0
			end
			if timer == 105
				S_StartSound(nil,sfx_bkpoof)
				S_StartSound(nil,sfx_fortun)
				
				local boom = P_SpawnMobj(mo.x,mo.y,mo.z+(FRACUNIT*32), MT_DUMMY)
                boom.scale = FRACUNIT*2
				boom.angle = mo.angle
                boom.frame = A|FF_FULLBRIGHT
				boom.color = SKINCOLOR_FLAME
				boom.fuse = 20
				boom.tics = 20
				boom.momx = (target.x - boom.x)/20
				boom.momy = (target.y - boom.y)/20
				boom.momz = ((target.z + FRACUNIT*16) - boom.z)/20
				
				local boom = P_SpawnMobj(mo.x,mo.y,mo.z+(FRACUNIT*32), MT_DUMMY)
                boom.scale = FRACUNIT*2
				boom.angle = mo.angle
                boom.frame = A|FF_FULLBRIGHT|FF_TRANS20
				boom.color = SKINCOLOR_FLAME
				boom.fuse = 21
				boom.tics = 21
				boom.momx = (target.x - boom.x)/21
				boom.momy = (target.y - boom.y)/21
				boom.momz = ((target.z + FRACUNIT*16) - boom.z)/21
				
				local boom = P_SpawnMobj(mo.x,mo.y,mo.z+(FRACUNIT*32), MT_DUMMY)
                boom.scale = FRACUNIT*2
				boom.angle = mo.angle
                boom.frame = A|FF_FULLBRIGHT|FF_TRANS40
				boom.color = SKINCOLOR_FLAME
				boom.fuse = 22
				boom.tics = 22
				boom.momx = (target.x - boom.x)/22
				boom.momy = (target.y - boom.y)/22
				boom.momz = ((target.z + FRACUNIT*16) - boom.z)/22
				
			end
			
			if timer == 125
				local boom = P_SpawnMobj(target.x,target.y,target.z, MT_DUMMY)
                boom.scale = 1
				boom.destscale = FRACUNIT*20
				boom.scalespeed = (FRACUNIT*20)/105
                boom.frame = A|FF_FULLBRIGHT
				boom.color = SKINCOLOR_FLAME
				boom.fuse = -1
				boom.tics = -1
				mo.finalblast = boom
			end
			if mo.finalblast and mo.finalblast.valid
				A_BossScream(mo.finalblast,1)
				S_StartSound(mo.finalblast,sfx_s3kb4)
			end
			if timer == 230
				DoExplosion(mo.finalblast)
				DoExplosion(mo.finalblast)
				mo.finalblast.state = S_FBOMB_EXPL1
				mo.finalblast = nil
			end
			
			if timer == 231
				for k,v in ipairs(hittargets)
					damageObject(v)
				end	
			end
			if timer == 280
				return true
			end
		end,
}


attackDefs["finaltrialmap"] = {
        name = "Loa's Map Loader",
        type = ATK_PASSIVE,
        desc = "Forces the map to change on the vision quest",
        passive = PSV_STARTBATTLE,
        anim = function(mo, targets, hittargets, timer)
            if G_BuildMapName() ~= "MAP45" //Nothing in () makes it check current map
                COM_BufInsertText(server, "map 45 -f") //Sends you to brazil... Maybe, literally?
            end //We didn't return true?!?! That's because PSV_STARTBATTLE only activates for ONE frame, and dont need no stinkn' returns
        end,
}

attackDefs["garkuti"] = {
        name = "Garkuti",
        type = ATK_PASSIVE,
        desc = "Nullify odds of being inflicted\non some status",
        passive = PSV_COND_RESIST,
        power = 100,
        status = COND_SHOCK|COND_BRAINWASH|COND_HEX|COND_SILENCE|COND_DESPAIR,
}