freeslot("SPR_ARHI", "sfx_hlycro", "sfx_hlycr2", "sfx_hlycr3", "sfx_arisc")


BTL_challengebtllist[#BTL_challengebtllist+1] = {
  name = "The Steel Maiden",
  description = {"A noble-minded warrior wishes", "to see your strength..."},
  level = 99,
  music = "ARIAN",
  time = TICRATE*60*59,
  items = {{"tearalbalm", 40}, {"spcharge3", 30}, {"curiabalm", 10}, {"recuriabalm", 5}, {"revbalm", 20}, {"celbalm", 10}, {"hypercombiring", 30}, {"soma", 2}, {"dekaja gem", 10}, {"stablet", 20}},
  waves = {
			{"arianrhod"},
		},
}


enemyList["arianrhod"] = {
		name = "Arianrhod",
		skillchance = 100,	
		level = 100,
		hp = 12500,
		sp = 9999,
		strength = 90,
		magic = 50,
		endurance = 99,
		luck = 42,
		agility = 70,
		melee_natk = "lance_jab",	
		thinker =     function(mo)
                        //S-Craft thinker
                        //Zoraxua note: This is really simple tbh
                        local enemies = mo.enemies
                        
                        if mo.hp < mo.maxhp*1/2 //Half health?
                            if not mo.healed //Lets prep first
                                mo.healed = true
                                return attackDefs["anglican_hammer"], enemies  //I'll give the skill
							elseif not mo.gonnabeatyourshitin
								mo.gonnabeatyourshitin = true
								return attackDefs["saint_aura"], {mo} //I'll give the skill
                            elseif not mo.scraft //Okay, now BAP once!
                                mo.scraft = true //Insert satk name in box below
                                return attackDefs["holy_grand_cross"], enemies 
                            end    
                        end//And otherwise,
                        return generalEnemyThinker(mo)
                    end,
		boss = true,
		endboss = true,
		turns = 2,
		
		

		anim_stand = 		{SPR_ARHI, A, 4},				-- standing
		anim_stand_hurt =	{SPR_ARHI, A, 4},					-- standing (low HP) *
		anim_stand_bored =	{SPR_ARHI, A, 4},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_ARHI, A, 4},				-- guarding
		anim_move =			{SPR_ARHI, A, 4},	-- moving
		anim_run =			{SPR_ARHI, A, 4},	-- guess what
		anim_atk =			{SPR_ARHI, A, 4},			-- attacking
		anim_aoa_end =		{SPR_ARHI, A, 4},			-- jumping out of all-out attack
		anim_hurt =			{SPR_ARHI, B, 30},				-- taking damage
		anim_getdown =		{SPR_ARHI, A, 4},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_ARHI, A, 4},					-- is down
		anim_getup =		{SPR_ARHI, A, 4},			-- gets up from down
		anim_death =		{SPR_ARHI, C, 4},					-- dies
		anim_revive =		{SPR_ARHI, A, 4},			-- gets revived
		anim_evoker =		{SPR_ARHI, A, 4},
		anim_evoker_shoot = {SPR_ARHI, A, 4},
		anim_special1 =		{SPR_ARHI, D, 4},
		anim_special2 =		{SPR_ARHI, E, 4},
		anim_special3 =		{SPR_ARHI, F, 4},
		
		vfx_skill = {"sfx_ariat1", "sfx_ariat2", "sfx_ariat3", "sfx_ariat4"},
		vfx_hurt = {"sfx_arihr1", "sfx_arihr2", "sfx_arihr3"},
		vfx_crit = {"sfx_arict1", "sfx_arict2", "sfx_arict3", "sfx_arict4", "sfx_arict5"},
		vfx_dodge = {"sfx_arimi1", "sfx_arimi2"},
		
		hudcutin = "ARHI_A",	-- cut in
		color = SKINCOLOR_SUPERGOLD3,
		
		skills = {"status_removal", "divine_riser", "counterstrike", "dekakunda", "anglican_hammer", "steelmaidenmap", "ultimate_saber", "sturm_lanzer"},
		
		deathanim = function(mo)

						mo.deathtimer = $ and $+1 or 1

						if mo.deathtimer == 1

							for p in players.iterate do
								if p and p.control and p.control.valid and p.control.battlen == mo.battlen
									S_FadeOutStopMusic(200, p)
								end
							end

							mo.basecoords = {mo.x, mo.y, mo.z}
							mo.flags = $|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							ANIM_set(mo, mo.anim_hurt)

							local cam = server.P_BattleStatus[mo.battlen].cam
							local destx = mo.x + 192*cos(mo.angle)
							local desty = mo.y + 192*sin(mo.angle)
							CAM_goto(cam, destx, desty, mo.z + FRACUNIT*8)
							CAM_angle(cam, R_PointToAngle2(destx, desty, mo.x, mo.y))

						elseif mo.deathtimer < TICRATE*2

							P_TeleportMove(mo, mo.basecoords[1] + P_RandomRange(-4, 4)*FRACUNIT, mo.basecoords[2] + P_RandomRange(-4, 4)*FRACUNIT, mo.basecoords[3] + P_RandomRange(-4, 4)*FRACUNIT)
							mo.anim_time = 0

						elseif mo.deathtimer == TICRATE*2
							P_TeleportMove(mo, mo.basecoords[1], mo.basecoords[2], mo.basecoords[3])
							ANIM_set(mo, mo.anim_death)
							mo.flags = $ & ~(MF_NOCLIPHEIGHT|MF_NOGRAVITY)

						elseif mo.deathtimer == TICRATE*3
							mo.hp = 1	-- hack
							mo.deathanim = nil
							D_startEvent(mo.battlen, "ev_ariadefeated")
							return	-- deref
						end
					end,
}

attackDefs["lance_jab"] = {
		name = "Lance Jab",
		type = ATK_PIERCE,
		power = 500,
		accuracy = 97,
		costtype = CST_HP,
		cost = 0,
		critical = 2,
		physical = true,
		desc = "Heavy Pierce damage to a enemy.\nArianrhod's normal attack",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer >= 15 and timer <= 45
			and not (timer%2)

				local shot = P_SpawnMobj(target.x + P_RandomRange(-150, 150)*FRACUNIT, target.y + P_RandomRange(-150, 150)*FRACUNIT, target.z + P_RandomRange(0, 150)*FRACUNIT, MT_DUMMY)
				if not (timer%4)
					playSound(mo.battlen, sfx_rail1)
				end
				shot.state = S_STAB_1_1
				shot.color = SKINCOLOR_WHITE
				shot.scale = $ + P_RandomRange(0, 65535)*3

				if not (timer%8)
					createSplat(mo)
					localquake(mo.battlen, FRACUNIT*4, 4)
				end

			end
			
			if timer == 55
				local shot = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				shot.state = S_STAB_1_1
				shot.color = SKINCOLOR_WHITE
				shot.scale = FRACUNIT*3
				playSound(mo.battlen, sfx_hit)

				local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
				d.sprite = SPR_THMP
				d.frame = A|FF_FULLBRIGHT
				d.scale = FRACUNIT/4
				d.destscale = FRACUNIT*4
				d.scalespeed = FRACUNIT/8
				d.fuse = TICRATE-10
				d.tics = d.fuse
				d.momz = FRACUNIT*2
				d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.color = SKINCOLOR_WHITE
			end	

			if timer == 56
				damageObject(target)
			elseif timer == 70
				return true
			end
		end,
}		

attackDefs["divine_riser"] = { --Excuse for a buff skill
		name = "Divine Riser",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 24,
		desc = "Raise all of an ally's stats \nby 1 stage.",
		target = TGT_ALLY,
		superbuff = true,
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.buffs["atk"][1] >= 75
						and target.buffs["mag"][1] >= 75
						and target.buffs["agi"][1] >= 75
						and target.buffs["def"][1] >= 75
						and target.buffs["crit"][1] >= 75
							BTL_logMessage(targets[1].battlen, "Limit reached!")
							return true
						end
					end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			local colors = {SKINCOLOR_ORANGE, SKINCOLOR_TEAL, SKINCOLOR_LAVENDER, SKINCOLOR_EMERALD, SKINCOLOR_YELLOW}

			if timer == 20
				playSound(mo.battlen, sfx_buff)
				buffStat(target, "atk")
				buffStat(target, "mag")
				buffStat(target, "def")
				buffStat(target, "agi")
				buffStat(target, "crit")

				BTL_logMessage(targets[1].battlen, "All stats increased!")

				for i = 1,16
					local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_WHITE
					dust.scale = FRACUNIT*2
				end

			elseif timer > 20 and timer <= 50

				if leveltime%2 == 0
					for i = 1,16

						local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.state = S_CDUST1
						thok.momz = P_RandomRange(3, 10)*FRACUNIT
						thok.color = SKINCOLOR_WHITE
						thok.tics = P_RandomRange(10, 35)
						thok.scale = FRACUNIT*3/2
					end
				end

				for i = 1, 8
					local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
					thok.momz = P_RandomRange(6, 16)*FRACUNIT
					thok.color = colors[P_RandomRange(1, #colors)]
					thok.tics = P_RandomRange(10, 35)
				end
			elseif timer == 60
				return true
			end
		end,
}



attackDefs["anglican_hammer"] = {
	name = "Anglican Hammer",
	type = ATK_ELEC,
	power = 710,
	accuracy = 97,
	costtype = CST_HP,
	cost = 30,
	status = COND_SHOCK,
	statuschance = 10,
	critical = 2,
	desc =	"Severe Elec damage to all enemies. \nHigh chance of shock.",
	target = TGT_ALLENEMIES,
	anim_norepel = true,	-- do not bounce back our ANIMATION
	anim = function(mo, targets, hittargets, timer)
		
		if timer == 10
			ANIM_set(mo, mo.anim_special1, true)
			playSound(mo.battlen, sfx_zio5)
		end	
		
		if timer >= 10
		and timer <= 50
		and leveltime%2 == 0
		
			local range = 60
			if timer >= 50
				range = 100
			end
			local s = P_SpawnMobj(mo.x + P_RandomRange(-range, range)*mo.scale, mo.y + P_RandomRange(-range, range)*mo.scale, mo.floorz + P_RandomRange(0, 100)*mo.scale, MT_DUMMY)
			s.state, s.scale, s.color = S_LZIO21, mo.scale*15/4, SKINCOLOR_YELLOW
			s.destscale = mo.scale*3/2
		end	
		
		if timer == 55
		or timer == 65

			if timer == 55
				playSound(mo.battlen, sfx_zio3)
			end
			local ang = 0
			for i = 1, 24 do
				local f = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
				f.state = S_KSPARK1
				f.scale = FRACUNIT/2
				f.fuse = TICRATE
				f.destscale = FRACUNIT*4
				f.color = SKINCOLOR_YELLOW
				f.colorized = true
				f.friction = FRACUNIT
				f.angle = ang
				P_InstaThrust(f, f.angle, 50*FRACUNIT)

				f = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
				f.state = S_KSPARK1
				f.scale = FRACUNIT
				f.fuse = TICRATE
				f.friction = FRACUNIT
				f.destscale = FRACUNIT*4
				f.angle = ang
				f.color = SKINCOLOR_YELLOW
				f.colorized = true
				P_InstaThrust(f, f.angle, 60*FRACUNIT)

				for i = 1, 8
					f = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					f.state = S_KSPARK1
					f.fuse = TICRATE
					f.friction = FRACUNIT
					f.scale = FRACUNIT/2
					f.color = SKINCOLOR_YELLOW
					f.colorized = true
					f.destscale = FRACUNIT*4
					f.angle = ang + P_RandomRange(-15, 15)*ANG1
					P_InstaThrust(f, f.angle, 50*FRACUNIT + P_RandomRange(-16, 16)*FRACUNIT)
				end
				ang = $ + (360/24)*ANG1
			end
		end	
	
		
		if timer == 70
			for k,v in ipairs(hittargets)
				damageObject(v)
			end
		end
		
		if timer == 110
			return true
		end
	end,
}	
	
	
attackDefs["ultimate_saber"] = {	
		name = "Ultimate Saber",
		type = ATK_STRIKE,
		power = 710,
		accuracy = 97,
		costtype = CST_HP,
		cost = 30,
		critical = 2,
		desc =	"Severe Strike dmg to all enemies\nwith the side of the lance.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)	
			local avgx, avgy = 0, 0
			for i = 1, #hittargets -- Get average position of targets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT	

			if timer < 30
				if timer == 1
					playSound(mo.battlen, sfx_ltchr)
				end
				local h_angle = P_RandomRange(1, 359)*ANG1
				local v_angle = P_RandomRange(1, 359)*ANG1
				local dist = 256
				local spd = P_RandomRange(40, 50)

				local s_x = mo.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
				local s_y = mo.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
				local s_z = (mo.z+mo.height/2)+ dist* sin(v_angle)

				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_YELLOW
				s.scale = FRACUNIT*1
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (mo.x - s.x)/10
				s.momy = (mo.y - s.y)/10
				s.momz = (mo.z - s.z)/10
					
				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_YELLOW
				s.scale = FRACUNIT*1
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (mo.x - s.x)/10
				s.momy = (mo.y - s.y)/10
				s.momz = (mo.z - s.z)/10
				
				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_YELLOW
				s.scale = FRACUNIT*1
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (mo.x - s.x)/10
				s.momy = (mo.y - s.y)/10
				s.momz = (mo.z - s.z)/10
			end

			if timer == 30
				local s = P_SpawnMobj(avgx, avgy, mo.z+1*FRACUNIT, MT_DUMMY)
				s.state = S_SLASHING_1_1
				s.color = SKINCOLOR_WHITE
				s.scale = FRACUNIT*7
				playSound(mo.battlen, sfx_slash)

			elseif timer == 32
				local d = P_SpawnMobj(avgx, avgy, mo.z+128*FRACUNIT, MT_THOK)
				d.sprite = SPR_THMP
				d.frame = C|FF_FULLBRIGHT
				d.scale = FRACUNIT/4
				d.destscale = FRACUNIT*5
				d.scalespeed = FRACUNIT/8
				d.fuse = TICRATE-10
				d.tics = d.fuse
				d.momz = FRACUNIT*2
				d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.color = SKINCOLOR_WHITE

			elseif timer == 34
				localquake(mo.battlen, FRACUNIT*10, 10)
				for i=1,10
					local b = P_SpawnMobj(avgx, avgy, mo.z+20*FRACUNIT, MT_DUMMY)
					b.momx = P_RandomRange(-35, 35)*FRACUNIT
					b.momy = P_RandomRange(-35, 35)*FRACUNIT
					b.momz = P_RandomRange(-35, 35)*FRACUNIT
					b.color = SKINCOLOR_RED
					b.frame = A|FF_FULLBRIGHT
					b.scale = FRACUNIT/2
					b.destscale = FRACUNIT/12
					b.tics = 35
				end

				local s = P_SpawnMobj(avgx, avgy, mo.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = I|FF_FULLBRIGHT
				s.scale = FRACUNIT/2
				s.destscale = FRACUNIT*4
				s.scalespeed = FRACUNIT/3
				s.color = SKINCOLOR_ORANGE
			end	

			if timer >= 34
			and timer <= 70
				local baseangle = P_RandomRange(1, 380)*ANG1
				local dist = 256
				for i = 1, 16
					local angle = baseangle + i*6*ANG1
					local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)
					local aura = P_SpawnMobj(x, y, mo.z + mo.height/5 + i*FRACUNIT*4, MT_DUMMY)
					aura.state = S_AURA1
					aura.angle = angle - ANGLE_90
					aura.color =  	SKINCOLOR_SUPERGOLD2
					aura.momz = P_RandomRange(3, 5)*FRACUNIT
					aura.scale = FRACUNIT*3
					aura.destscale = FRACUNIT*5
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(2, 2))
				end
			end
			
			if timer == 71
				for k,v in ipairs(hittargets)
					damageObject(v)
					playSound(mo.battlen, sfx_lydhit)
				end
			end
			
			if timer == 90
				return true
			end
		end,
}

attackDefs["sturm_lanzer"] = {
	name = "Sturm Lanzer",
	type = ATK_PIERCE,
	power = 1000,
	accuracy = 97,
	costtype = CST_HP,
	cost = 30,
	critical = 2,
	desc =	"Colossal Pierce damage to a enemy\nLowers Agility by 2 stages",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
	
		local target = hittargets[1]
		
		if timer == 15
			local shot = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
			shot.state = S_STAB_1_1
			shot.color = SKINCOLOR_WHITE
			shot.scale = FRACUNIT*3
			playSound(mo.battlen, sfx_hit)
		end	
		
		if timer >= 18 and timer <= 70 and timer%2 == 0
			local shot = P_SpawnMobj(target.x, target.y, target.z+50*FRACUNIT, MT_THOK)
			shot.sprite = SPR_STAB
			shot.frame = A|FF_FULLBRIGHT|TR_TRANS50
			if timer%4 == 0 shot.color = SKINCOLOR_WHITE else shot.color = SKINCOLOR_SILVER end
			shot.destscale = FRACUNIT*2
			shot.scalespeed = FRACUNIT/2
			playSound(mo.battlen,sfx_rail2)
			playSound(mo.battlen,sfx_spkdth)
			local ang = R_PointToAngle(target.x, target.y) + ANG1*120

			for j = 1, 16

				local boom = P_SpawnMobj(target.x + P_RandomRange(-20,20)*FRACUNIT, target.y + P_RandomRange(-20,20)*FRACUNIT, target.z + 64*mo.scale + P_RandomRange(-20,20)*FRACUNIT, MT_DUMMY)
				boom.state = S_SSHOT1
				boom.color = SKINCOLOR_AETHER
				boom.angle = ang
				P_InstaThrust(boom, boom.angle, P_RandomRange(16, 64)*FRACUNIT)
				boom.momz = P_RandomRange(6, 16)*FRACUNIT
				boom.scale = FRACUNIT*3/2
				P_StartQuake(FRACUNIT*3,5)
			end
			
			if timer == 66
				damageObject(target)
				playSound(mo.battlen, sfx_megi6)
                if target.damagestate ~= DMG_MISS
                and target.damagestate ~= DMG_BLOCK
                and target.damagestate ~= DMG_DRAIN  
                    buffStat(target, "agi", -50)
                end    
			end
		
		elseif timer == 100
			return true
		end
			
	end,
}




attackDefs["saint_aura"] = {
		name = "Saint's Aura",
		dekunda = true,
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 20,
		nometronome = true,
		norandom = true,
		desc = "Remove debuffs and buffs\nyourself to maximum",
		target = TGT_CASTER,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local strs = {"atk", "mag", "def", "agi", "crit"}
			
			if timer == 10
				S_StartSound(nil, sfx_hama3)
				S_StartSound(nil, sfx_arisc)
				ANIM_set(mo, mo.anim_special2, true)
			elseif timer >= 10 and timer <= 80
				summonAura(mo, SKINCOLOR_SUPERGOLD4)
			end	
			
			if timer == 15
				for j = 1, #strs
					local t = hittargets[1]
					local s = strs[j]
					if t.buffs[s][1] < 0
						t.buffs[s][1] = 0
						t.buffs[s][2] = 0
					end
				end
			end	
			
			if timer >= 25
			and timer <= 50
				if not (timer%4)
					for i = 1,16
						local thok = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
						thok.state = S_SSPK1
						thok.angle = ANGLE_22h*(i-1)
						P_InstaThrust(thok, thok.angle, 69*FRACUNIT)
					end	
				end
			end	
			
			if timer == 60
				ANIM_set(mo, mo.anim_special3, true)
                buffStat(target, "atk", 50)
                buffStat(target, "def", 50)
                buffStat(target, "agi", 50)
				buffStat(target, "mag", 50)
				buffStat(target, "crit", 50)
				BTL_logMessage(targets[1].battlen, "All stats increased x2!\nDebuffs Removed!\nPreparing a powerful attack...")
				playSound(mo.battlen, sfx_buff)
				playSound(mo.battlen, sfx_hamas2)
			end

			if timer == 61
				local thok = P_SpawnMobj(mo.x, mo.y, mo.z+5*FRACUNIT, MT_DUMMY)
				thok.state = S_INVISIBLE
				thok.tics = 1
				A_OldRingExplode(thok, MT_SUPERSPARK)
			end	


			if timer == 100
				return true
			end
		end,
}

attackDefs["dekakunda"] = {
    name = "Dekakunda",
    dekaja = true,
    dekunda = true,
    type = ATK_SUPPORT,
    costtype = CST_SP,
    cost = 20,
    desc = "Remove enemy buffs\nand party debuffs.",
    target = TGT_EVERYONE,
    anim = function(mo, targets, hittargets, timer)
        local colors = {SKINCOLOR_ORANGE, SKINCOLOR_LAVENDER, SKINCOLOR_EMERALD, SKINCOLOR_YELLOW}
        local strs = {"atk", "mag", "def", "agi", "crit"}

        for i = 1, #targets
            local target = targets[i]
            if timer == 20 + (i-1)*10
                -- determine if this is an ally or foe
                local ally = true    -- assume it's an ally at first
                for j = 1, #mo.enemies
                    local enemy = mo.enemies[j]
                    if (enemy != target) then continue end
                    
                    -- if we're here, this is one of our enemies!
                    ally = false
                end
                
                -- visuals (consistent no matter what is casted)
                playSound(mo.battlen, sfx_status)
                for j = 1, 16
                    local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
                    orb.momx = P_RandomRange(-16, 16)<<FRACBITS
                    orb.momy = P_RandomRange(-16, 16)<<FRACBITS
                    orb.momz = P_RandomRange(-16, 16)<<FRACBITS
                    orb.destscale = 0
                    orb.frame = A
                    orb.color = colors[P_RandomRange(1, #colors)]
                end
                
                if (ally)    -- cast Dekunda
                    for j = 1, #strs
                        local s = strs[j]
                        if target.buffs[s][1] < 0
                            target.buffs[s][1] = 0
                            target.buffs[s][2] = 0
                        end
                    end
                    BTL_logMessage(targets[1].battlen, "Debuffs nullified")
                else    -- cast Dekaja
                    for j = 1, #strs
                        local s = strs[j]
                        if target.buffs[s][1] > 0
                            target.buffs[s][1] = 0
                            target.buffs[s][2] = 0
                        end
                    end
                    BTL_logMessage(targets[1].battlen, "Buffs nullified")
                end
            end
        end
        if timer == TICRATE*3/2 + (#targets-1)*10
            return true
        end
    end,
}



attackDefs["holy_grand_cross"] = {
	name = "Holy Grand Cross",
	type = ATK_ALMIGHTY,
	power = 5000,
	accuracy = 999,
	costtype = CST_HP,
	cost = 450,
	hits = 1,
	nometronome = true,
	norandom = true,
	critical = 20,
	desc = "Arianrhod's S-Craft\nUnleash a tornado torwards enemies\n and finish them off with a lance stab",
	target = TGT_ALLENEMIES,
	norepel = true,
	anim_norepel = true,
			hudfunc = 	function(v, mo, timer)
						
						if timer > 180
						and timer < 210
							local t = timer-180
							local p = "H_ATR"..t/2
							if v.patchExists(p)
								drawScreenwidePatch(v, v.cachePatch(p))
							end
						end
					end,
	anim = function(mo, targets, hittargets, timer)
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		if timer == 1
			ANIM_set(mo, mo.anim_special2, true)
			playSound(mo.battlen, sfx_cutlyd)
			playSound(mo.battlen, sfx_hlycro)
		end
		
		if timer < 35
			summonAura(mo, SKINCOLOR_FLAME)
		end
		
		if timer > 1 and timer < 35
			local boom = P_SpawnMobj(mo.x + P_RandomRange(-50, 50)*FRACUNIT, mo.y + P_RandomRange(-50, 50)*FRACUNIT, mo.z, MT_DUMMY)
			boom.state = S_QUICKBOOM1
			boom.colorized = true
			boom.color = SKINCOLOR_ORANGE
			boom.momz = P_RandomRange(0, 48)*FRACUNIT
			boom.scale = FRACUNIT*3/2
		end	
		
		if timer == 30
			ANIM_set(mo, mo.anim_special3, true)
			playSound(mo.battlen, sfx_wind4)
			local dust = P_SpawnMobj(avgx,avgy,mo.z,MT_DUSTDEVIL)
			dust.scale = max((FRACUNIT/2)*#hittargets,(FRACUNIT/2)*3)
			mo.nado = dust
		end
		if mo.nado and mo.nado.valid
			summonAura(mo.nado, SKINCOLOR_SUPERGOLD5)
		end	
		
		if timer == 35
			playSound(mo.battlen, sfx_athun2)
		end	
		
		if timer >= 35 and timer <= 120
			local bs = P_SpawnMobj(avgx + P_RandomRange(-200, 222)*FRACUNIT, avgy + P_RandomRange(-200, 222)*FRACUNIT, mo.z + P_RandomRange(0, 175)*FRACUNIT, MT_DUMMY)
			bs.state, bs.color = S_TRSPARKLE1, SKINCOLOR_GOLD
			bs.momz = P_RandomRange(-1, 1)*FRACUNIT
			bs.scale = 15/4*FRACUNIT
			bs.destscale = 3/2*FRACUNIT
		end	
		
		if timer >= 33 and timer <= 120
			for i = 1,#hittargets
				local target = hittargets[i]
				local shot = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
				shot.state = S_WINDBLOW1
				shot.colorized = true
				shot.color = SKINCOLOR_ORANGE		
				shot.scale = $ + P_RandomRange(5, 65535)*5
				if not (timer%8)
					localquake(mo.battlen, FRACUNIT*4, 4)
				end
			end
		end
		
		if timer >= 33 and timer <= 120
			if leveltime%8 == 0
				playSound(mo.battlen, sfx_lydhit)
				localquake(mo.battlen, FRACUNIT*10, 8)
			end
		end	
		
		if timer == 100
			playSound(mo.battlen, sfx_hlycr2)
		end
		
		if timer == 120
			mo.nado.fuse = 30
			mo.nado = nil
		end	
		
		for i = 1,#hittargets
			local target = hittargets[i]
			if timer == 150 + 8*(i-1)
				local shot = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				shot.state = S_STAB_1_1
				shot.color = SKINCOLOR_WHITE
				shot.scale = FRACUNIT*3
				playSound(mo.battlen, sfx_hit)

				local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
				d.sprite = SPR_THMP
				d.frame = A|FF_FULLBRIGHT
				d.scale = FRACUNIT/4
				d.destscale = FRACUNIT*4
				d.scalespeed = FRACUNIT/8
				d.fuse = TICRATE-10
				d.tics = d.fuse
				d.momz = FRACUNIT*2
				d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.color = SKINCOLOR_WHITE

			elseif timer == 156 + 8*(i-1)
				playSound(mo.battlen, sfx_rail1)
				ANIM_set(target, target.anim_hurt, true)
				localquake(mo.battlen, FRACUNIT*10, 10)
				for i = 1, 32 do
					local p = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*20, MT_DUMMY)
					p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
					p.state = S_SSPK1
					p.scale = mo.scale*2
					p.colorized = true
					p.color = SKINCOLOR_SUPERGOLD5
					p.angle = target.angle + P_RandomRange(-30, 30)*ANG1
					p.momz = P_RandomRange(-24, 24)*mo.scale
					P_InstaThrust(p, p.angle, mo.scale*64)
				end
			elseif timer == 157 + 8*(i-1)
				local slash = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				slash.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
				slash.sprite = SPR_SLAS
				slash.frame = C
				slash.scale = FRACUNIT*3
				slash.color = SKINCOLOR_SUPERGOLD5
				slash.tics = 50
			end
		end
		
		if timer == 165
			playSound(mo.battlen, sfx_hlycr3)
			playSound(mo.battlen, sfx_fortun)
		end	
		
		if timer >= 165 and timer < 210
			for i = 1,#hittargets
				local t = hittargets[i]
				summonAura(t, SKINCOLOR_SUPERORANGE5)
			end	
		end
		
		if timer == 211
			for i = 1,#hittargets
				local t = hittargets[i]
				DoExplosion(t)
			end
		end
		
		if timer == 212
			for k,v in ipairs(hittargets)
				damageObject(v)
			end	
		end

		if timer == 230 + 10*(#hittargets-1)
			return true
		end	
	end,
}

attackDefs["steelmaidenmap"] = {
        name = "Arianrhod's Map Loader",
        type = ATK_PASSIVE,
        desc = "Forces the map to change on the vision quest",
        passive = PSV_STARTBATTLE,
        anim = function(mo, targets, hittargets, timer)
            if G_BuildMapName() ~= "MAP46" //Nothing in () makes it check current map
                COM_BufInsertText(server, "map 46 -f") //Sends you to brazil... Maybe, literally?
            end //We didn't return true?!?! That's because PSV_STARTBATTLE only activates for ONE frame, and dont need no stinkn' returns
        end,
}

attackDefs["status_removal"] = {
        name = "Status Removal",
		type = ATK_PASSIVE,
		passive = PSV_STARTTURN,
		desc = "Recover from status.",
		showsp = true,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_EMERALD}
			if timer == 1
				if not mo.status_condition
					return true
				else
					if mo.status_condition == COND_HYPER
						return true
					elseif mo.status_condition == COND_SUPER
						return true
					else
						cureStatus(mo)
					end
				end
			end
			
			if timer == 1
				playSound(mo.battlen, sfx_curia)
				for j = 1, 16
					local orb = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					orb.momx = P_RandomRange(-16, 16)<<FRACBITS
					orb.momy = P_RandomRange(-16, 16)<<FRACBITS
					orb.momz = P_RandomRange(-16, 16)<<FRACBITS
					orb.destscale = 0
					orb.frame = A
					orb.color = colors[P_RandomRange(1, #colors)]
				end
			end	
			
			if timer == 35
				return true
			end
		end,
	}

for k, v in pairs(enemyList)
	VFX_freeslotE(k)
end